{*******************************************************}
{                                                       }
{            Avrora Card Gaming Components              }
{                                                       }
{            Copyright (c) 1999 Avrora LLC              }
{                                                       }
{*******************************************************}
{ This is PROPRIETARY SOURCE CODE of Avrora LLC;        }
{ the contents of this file may not be disclosed to     }
{ third parties, copied or duplicated in any form, in   }
{ whole or in part, without the prior written           }
{ permission of Avrora LLC.                             }
{*******************************************************}
{ VERSION 0.9.1.1                                       }
{ MOSCOW, APRIL 12, 1999 MONDAY.                        }
{ TO MY LOVELY WIFE ILONA.                              }
{*******************************************************}
{ CURRENT VERSION 0.9.5.6 UNPUBLISHED                   }
{*******************************************************}
  //BUG:
  //REPORTED:
  //FIXED:


unit ESCard;

{$DEFINE DEFAULTRES}
{$DEFINE xNETENABLE}

interface

uses
  ESGraphics, Windows, Messages, Classes, Graphics, Controls, Forms, StdCtrls,
  {$IFDEF NETENABLE}
  ESNetManager,
  {$ENDIF}
  ExtCtrls;

type

  { ENUMERATED }

  TESBackType = (cbDefault, cbLabyrinth, cbIvyBlack, cbIvyBlue, cbFishCyan, cbFishBlue, cbHawai, cbIceCream, cbRobot, cbTricky, cbFlower, cbCastle, cbX, cbO, cbDots);
  TESSuitType = (stClub, stDiamond, stHeart, stSpade, stJoker);
  TESTablePos = (tpAuto, tpBottom, tpLeft, tpTop, tpRight);
  TESCascadeStyle = (csNormal, csTight, csLoose);
  TESCascadeSide = (csRight, csDown);
  TESDeckType = (dcSingle, dcDouble);
  //BUG: Cannot use ssNone at runtime because it is used in VCL
  //REPORTED: 03-09-1999 by Craig EDGAR
  //FIXED: 03-09-1999 by Ecmel ERCAN
  //TESSortStyle = (ssNone, ssSuit, ssValue);
  TESSortStyle = (soNone, soSuit, soValue);
  TESTableDir = (tdClockWise, tdCounterClockWise);
  TESCardColor = (ccBlack, ccRed, ccNone);
  {$IFDEF NETENABLE}
  TESController = (ctHuman, ctComputer, ctNetwork);
  {$ELSE}
  TESController = (ctHuman, ctComputer);
  {$ENDIF}

  { TYPES }

  TESSortRecord = record
    Key : Integer;
    Data : Integer;
  end;
  TESSortArray = array of TESSortRecord;

  TESCardInfo = record
    ID : Integer;
    ShowBack : Boolean;
    Empty : Boolean;
  end;
  TESCardInfos = array of TESCardInfo;

  TESArrayInt = array of Integer;

  { FORWARD CLASS DECLERATIONS }

  TESCardGroup = class;
  TESCardTable = class;
  TESCardDeck = class;
  TESCustomCardControl = class;
  TESSinglecard = class;

  { PROCEDURAL TYPES }

  TESCardClickEvent = procedure(Sender : TESCardGroup; Card : TESSingleCard; Position : Integer; var PlayIt : Boolean; var TablePos : TESTablePos) of object;
  TESBeforePlayEvent = procedure(Sender : TESCardGroup; var Position : Integer; var TablePos : TESTablePos) of object;
  TESCardGroupNotifyEvent = procedure(Sender : TESCardGroup) of object;
  TESCardTableNotifyEvent = procedure(Sender : TESCardTable) of object;
  TESCardTableAddCardEvent = procedure(Sender : TESCardTable; PlayedCardsCount, TopCardPos: Integer; TopCard : TESSingleCard; TopCardID, PrevCardID : Integer; OwnedCard: Boolean) of object;
  TESCardTableBeforeAddCardEvent = procedure(Sender : TESCardTable; Card : TESSingleCard; SuitExists : Boolean; var Accept : Boolean) of object;
  TESCardTableAfterDealtoTableEvent = procedure(Sender : TESCardTable; PlayedCardsCount, TopCardPos: Integer; TopCard : TESSingleCard) of object;
  TESCardTableCardClickEvent = procedure(Sender : TESCardTable; TopCard : TESSingleCard; var TakeIt : Boolean) of object;
  TESCardDeckCardClickEvent = procedure(Sender : TESCardDeck; var TakeIt : Boolean) of object;

  { CLASSES } {----------------------------------------------------------------}

  {

  OWNED means the pointer is created and destroyed by the object itself.
  NIL   means the pointer is not created by the object itself and can be set to nil.

  }

  TESPointItem = class(TCollectionItem)
  private
    FCardID : Integer;
    FPoints : Integer;
  public
    constructor Create(ACollection: TCollection); override;
  published
    property CardID : Integer read FCardID write FCardID default 14;
    property Points : Integer read FPoints write FPoints default 1;
  end;

  {----------------------------------------------------------------------------}

  TESPointList = class (TOwnedCollection)
  private
    FOwner : TESCustomCardControl;  { NIL }
    function GetItem(Index: Integer): TESPointItem;
    procedure SetItem(Index: Integer; Value: TESPointItem);
  public
    constructor Create(AOwner : TESCustomCardControl; ACollectionItemClass : TCollectionItemClass);
    property Items[Index: Integer]: TESPointItem read GetItem write SetItem; default;
    function Add   : TESPointItem;
    property Owner : TESCustomCardControl read FOwner;
  end;

  {----------------------------------------------------------------------------}

  TESCardItem = class(TCollectionItem)
  private
    FCard : TESSingleCard; { OWNED }
    procedure SetCard(const Value: TESSingleCard);
  public
    constructor Create(ACollection: TCollection); override;
    destructor Destroy; override;
  published
    property Card : TESSingleCard read FCard write SetCard;
  end;

  {----------------------------------------------------------------------------}

  TESCardList = class (TOwnedCollection)
  private
    FOwner : TESCustomCardControl;    { NIL }
    function GetItem(Index: Integer): TESCardItem;
    procedure SetItem(Index: Integer; Value: TESCardItem);
  protected
    procedure Update(Item: TCollectionItem); override;
  public
    constructor Create(AOwner : TESCustomCardControl; ACollectionItemClass : TCollectionItemClass);
    property Items[Index: Integer]: TESCardItem read GetItem write SetItem; default;
    function Add   : TESCardItem;
    property Owner : TESCustomCardControl read FOwner;
    procedure Clear;
  end;

  {----------------------------------------------------------------------------}

  TESPlayerItem = class(TCollectionItem)
  private
    FCardGroup : TESCardGroup;  { NIL }
    procedure SetCardGroup(const Value: TESCardGroup);
  published
    property CardGroup : TESCardGroup read FCardGroup write SetCardGroup default nil;
  end;

  {----------------------------------------------------------------------------}

  TESPlayerList = class (TOwnedCollection)
  private
    FOwner : TESCustomCardControl;  { NIL }
    function GetItem(Index: Integer): TESPlayerItem;
    procedure SetItem(Index: Integer; Value: TESPlayerItem);
  public
    property Items[Index: Integer]: TESPlayerItem read GetItem write SetItem; default;
    constructor Create(AOwner : TESCustomCardControl; ACollectionItemClass : TCollectionItemClass);
    function Add   : TESPlayerItem;
    property Owner : TESCustomCardControl read FOwner;
  end;

  {----------------------------------------------------------------------------}

  TESSingleCard = class(TPersistent)
  private
    { POINTERS }

    FFaceBitmap  : TBitmap;                 { OWNED }
    FBackBitmap  : TBitmap;                 { OWNED }
    FPaintBitmap : TBitmap;                 { OWNED }
    FOwner       : TESCustomCardControl;    { NIL }
    FCardOwner   : TESCardGroup;            { NIL }
    FSprite      : TESCustomSprite;         { NIL }
    FTable       : TESCardTable;            { NIL }

    { ENUMERATED }

    FSuit     : TESSuitType;
    FCardBack : TESBackType;
    FCardColor: TESCardColor;

    { PRIMITIVES }

    FEmpty    : Boolean;
    FShowBack : Boolean;
    FReserved : Boolean;
    FID       : Integer;
    FValue    : Integer;
    FPosition : Integer;
    FValueKey : Integer;
    FSuitKey  : Integer;
    FTag      : Integer;
    FArea     : TRect;

    procedure SetEmpty(const Value: Boolean);
    procedure SetID(const Value: Integer);
    procedure SetShowBack(const Value: Boolean);
    procedure SetSuit(const Value: TESSuitType);
    procedure SetValue(const Value: Integer);
    procedure SetCardBack(const Value: TESBackType);
    procedure SetPosition(const Value: Integer);
    function GetLeft: Integer;
    function GetTop: Integer;
    function GetHeight: Integer;
    function GetWidth: Integer;
  protected
    procedure Play(TablePos : TESTablePos = tpAuto);
    procedure Draw(PaintAll : Boolean = False);
    property Sprite : TESCustomSprite read FSprite write FSprite;
    property Table : TESCardTable read FTable write FTable;
    property PaintBitmap : TBitmap read FPaintBitmap;
    function  GetOwner: TPersistent; override;
    property ValueKey : Integer read FValueKey;
  public
    constructor Create(AOwner : TESCustomCardControl; APaintBitmap : TBitmap);
    destructor Destroy; override;
    procedure Assign(Dest : TPersistent); override;
    property Owner : TESCustomCardControl read FOwner;
    property BackBitmap : TBitmap read FBackBitmap;
    property FaceBitmap : TBitmap read FFaceBitmap;
    property CardOwner : TESCardGroup read FCardOwner write FCardOwner;
    property CardColor : TESCardColor read FCardColor;
    function NextColor : TESCardColor;
    function NextValue : Integer;
    function PrevValue : Integer;
    function NextID : Integer;
    function PrevID : Integer;
    property Tag : Integer read FTag write FTag;
    property Position : Integer read FPosition write SetPosition default 0;
    property Left : Integer read GetLeft;
    property Top : Integer read GetTop;
    property Width : Integer read GetWidth;
    property Height : Integer read GetHeight;
  published
    property ID : Integer read FID write SetID default 14;
    property Value : Integer read FValue write SetValue stored False;
    property Suit : TESSuitType read FSuit write SetSuit stored False;
    property CardBack : TESBackType read FCardBack write SetCardBack default cbDefault;
    property ShowBack : Boolean read FShowBack write SetShowBack default True;
    property Empty : Boolean read FEmpty write SetEmpty default False;
    property Reserved : Boolean read FReserved write FReserved default False;
  end;

  {----------------------------------------------------------------------------}

  TESCustomCardControl = class(TESCustomGraphicControl)
  private
    { POINTERS }

    FSprite: TESCustomSprite;  { NIL }

    { ENUMERATED }

    FCardBack : TESBackType;

    { PRIMITIVES }

    FShowBack  : Boolean;
    FAutoEmpty : Boolean;
    FBusy      : Boolean;
    FLockCount : Integer;
    FAfterBusy : TNotifyEvent;

    procedure SetAutoEmpty(const Value: Boolean);
    procedure SetCardBack(const Value: TESBackType); virtual;
    procedure SetShowBack(const Value: Boolean); virtual;
    procedure SetSprite(const Value: TESCustomSprite); virtual;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Lock;
    procedure UnLock;
  public
    constructor Create(AOwner : TComponent); override;
    property Busy : Boolean read FBusy;
    property PaintBitmap;
  published

    { INHERITED }

    property AutoSize;
    property Color;
    property Action;
    property ShowHint;
    property ParentShowHint;
    property Width;
    property Height;
    property Align;
    property Anchors;
    property Constraints;
    property PopupMenu;
    property DragCursor;
    property DragMode;
    property DragKind;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnEndDock;
    property OnStartDock;
    property OnConstrainedResize;
    property Visible;

    { UNIQUE PROPERTIES }

    property CardBack : TESBackType read FCardBack write SetCardBack default cbDefault;
    property ShowBack : Boolean read FShowBack write SetShowBack default True;
    property AutoEmpty : Boolean read FAutoEmpty write SetAutoEmpty default False;
    property AfterBusy : TNotifyEvent read FAfterBusy write FAfterBusy;
    property Sprite : TESCustomSprite read FSprite write SetSprite default nil;
  end;


  { VISUAL COMPONENTS ---------------------------------------------------------}

  TESCardGroup = class(TESCustomCardControl)
  private
    { POINTERS }

    FCardList      : TESCardList;    { OWNED }
    FNonEmptyCards : TESArrayInt;    { OWNED }
    FSavedCards    : TESCardInfos;   { OWNED }
    FTakenCards    : TESArrayInt;    { OWNED }
    FTable         : TESCardTable;   { NIL }
    FScoreLabel    : TLabel;         { NIL }
    FNameLabel     : TLabel;         { NIL }

    { ENUMERATED }

    FCardCursor      : TCursor;
    FCascadeStyle    : TESCascadeStyle;
    FOldCascadeStyle : TESCascadeStyle;
    FCascadeSide     : TESCascadeSide;
    FTablePlayPos    : TESTablePos;
    FController      : TESController;
    FSortStyle       : TESSortStyle;
    FShowSortStyle   : TESSortStyle;
    FOldSortStyle    : TESSortStyle;

    { PRIMITIVES }

    FShowOnlyPointCards : Boolean;
    FShowAutoTight      : Boolean;
    FOldShowBack        : Boolean;
    FAutoTight          : Boolean;
    FRandomCards        : Boolean;
    FDealer             : Boolean;
    FOnlyCalcArea       : Boolean;
    FOldCount           : Integer;
    FCardCount          : Integer;
    FTightness          : Integer;
    FScore              : Integer;
    FPlayDelay          : Integer;
    FPlayerName         : String;

    { PROCEDURAL }

    FAfterScoreChange : TESCardGroupNotifyEvent;
    FAfterCardTake    : TESCardGroupNotifyEvent;
    FBeforePlay       : TESBeforePlayEvent;
    FOnCardClick      : TESCardClickEvent;
    FAfterUpdate      : TESCardGroupNotifyEvent;

    procedure SetCascadeStyle(const Value: TESCascadeStyle);
    procedure SetCascadeSide(const Value: TESCascadeSide);
    procedure SetCardTable(const Value: TESCardTable);
    procedure SetTightness(const Value: Integer);
    procedure SetAutoTight(const Value: Boolean);
    procedure SetSortStyle(const Value: TESSortStyle);
    procedure SetRandomCards(const Value: Boolean);
    procedure SetTakenCards(Index: Integer; const Value: Integer);
    procedure SetDealer(const Value: Boolean);
    procedure SetScore(const Value: Integer);
    procedure SetPlayerName(const Value: String);
    procedure SetNameLabel(const Value: TLabel);
    procedure SetScoreLabel(const Value: TLabel);
    function GetCards(Index: Integer): TESSingleCard;
    function GetNonEmptyCards(Index: Integer): TESSingleCard;
    function GetTakenCards(Index: Integer): Integer;
    procedure SetSprite(const Value: TESCustomSprite); override;
    procedure SetShowBack(const Value: Boolean); override;
    procedure SetCardBack(const Value: TESBackType); override;
    procedure SetPlayDelay(const Value: Integer);
  protected
    procedure PlayCard;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure RepaintCanvas(PaintAll : Boolean); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure Click; override;
    procedure CalcAutoTight;
    procedure Resize ; override;
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

    procedure DragDrop(Source: TObject; X, Y: Integer); override;

    { AI SUPPORT ROUTINES }

    property NonEmptyCards[Index : Integer] : TESSingleCard read GetNonEmptyCards;
    function NonEmptyCardsCount: Integer;
    function FindRandomCard: TESSingleCard;
    function FindRandomCardPos : Integer;
    function FindSuitPos(Suit : TESSuitType) : Integer;
    function FindMinSuitPos(Suit : TESSuitType) : Integer;
    function FindMaxSuitPos(Suit : TESSuitType) : Integer;
    function FindMinValuePos : Integer;
    function FindMaxValuePos : Integer;
    function FindMaxSuitPosInvert(Suit : TESSuitType) : Integer;
    function FindMinSuitPosInvert(Suit : TESSuitType) : Integer;
    function FindValuePos(Value : Integer) : Integer;
    function FindIDPos(ID : Integer) : Integer;

    { CARD GROUP MANAGEMENT ROUTINES }

    property Cards[Index : Integer] : TESSingleCard read GetCards; default;
    property CardsCount : Integer read FCardCount;
    procedure Sort(ASortStyle : TESSortStyle);
    procedure Play(Pos : Integer; TablePos : TESTablePos = tpAuto);
    procedure Clear;
    procedure SwitchPos(A, B : Integer);
    procedure InsertPos(A, B : Integer);
    procedure SaveCards;
    procedure LoadCards;
    procedure Reset(ClearAlso : Boolean = False);
    procedure DeleteLastCard;
    function FindReservedPos : Integer;
    function FindMousePos(X, Y : Integer) : Integer;
    function LastCard : TESSingleCard;


    { TAKEN CARDS SUPPORT ROUTINES }

    property TakenCards[Index : Integer] : Integer read GetTakenCards write SetTakenCards;
    function TakenCardsCount: Integer;
    function TakenCardsPoints : Integer;
    procedure AddToTakenCards(CardIDArray : TESArrayInt);
    procedure ShowTakenCards;
    procedure HideTakenCards;
    procedure ClearTakenCards;

  published

    { INHERITED }

    property Empty default False;

    { EVENTS }

    property OnCardClick : TESCardClickEvent read FOnCardClick write FOnCardClick;
    property BeforePlay : TESBeforePlayEvent read FBeforePlay write FBeforePlay;
    property AfterCardTake : TESCardGroupNotifyEvent read FAfterCardTake write FAfterCardTake;
    property AfterScoreChange : TESCardGroupNotifyEvent read FAfterScoreChange write FAfterScoreChange;
    property AfterUpdate : TESCardGroupNotifyEvent read FAfterUpdate write FAfterUpdate;

    { UNIQUE PROPERTIES }

    property CardList : TESCardList read FCardList write FCardList;
    property Table : TESCardTable read FTable write SetCardTable default nil;
    property PlayerNameLabel : TLabel read FNameLabel write SetNameLabel default nil;
    property ScoreLabel : TLabel read FScoreLabel write SetScoreLabel default nil;

    property CascadeStyle : TESCascadeStyle read FCascadeStyle write SetCascadeStyle default csNormal;
    property CascadeSide : TESCascadeSide read FCascadeSide write SetCascadeSide default csRight;
    property CardCursor : TCursor read FCardCursor write FCardCursor default crHandPoint;
    property SortStyle : TESSortStyle read FSortStyle write SetSortStyle default soNone;
    property ShowSortStyle : TESSortStyle read FShowSortStyle write FShowSortStyle default soNone;
    property Controller : TESController read FController write FController default ctHuman;
    property TablePlayPos : TESTablePos read FTablePlayPos write FTablePlayPos default tpAuto;

    property AutoTight : Boolean read FAutoTight write SetAutoTight default False;
    property RandomCards : Boolean read FRandomCards write SetRandomCards default False;
    property Dealer : Boolean read FDealer write SetDealer default False;
    property ShowOnlyPointCards : Boolean read FShowOnlyPointCards write FShowOnlyPointCards default True;
    property ShowAutoTight : Boolean read FShowAutoTight write FShowAutoTight default False;
    property Score : Integer read FScore write SetScore default 0;
    property Tightness : Integer read FTightness write SetTightness default 16;
    property PlayerName : String read FPlayerName write SetPlayerName;
    property PlayDelay : Integer read FPlayDelay write SetPlayDelay default 0;
  end;

  {----------------------------------------------------------------------------}

  TESCardTable = class(TESCustomCardControl)
  private

    { POINTERS }

    FPointList   : TESPointList;    { OWNED }
    FPlayerList  : TESPlayerList;   { OWNED }
    FCardLeft    : TESSingleCard;   { OWNED }
    FCardRight   : TESSingleCard;   { OWNED }
    FCardBottom  : TESSingleCard;   { OWNED }
    FCardTop     : TESSingleCard;   { OWNED }
    FDeck        : TESArrayInt;     { OWNED }
    FPlayedCards : TESArrayInt;     { OWNED }
    FTimer       : TTimer;          { OWNED }
    FCardDeck    : TESCardDeck;     { NIL }
    FLastTaker   : TESCardGroup;    { NIL }
    {$IFDEF NETENABLE}
    FNetManager  : TESNetManager;   { NIL }
    {$ENDIF}

    { ENUMERATED }

    FSuit             : TESSuitType;
    FDeckType         : TESDeckType;
    FStrongSuit       : TESSuitType;
    FAutoPosDirection : TESTableDir;

    { PRIMITIVES }

    FWaiting            : Boolean;
    FRandomCards        : Boolean;
    FDealAnimation      : Boolean;
    FSuitBroken         : Boolean;
    FSuitChecking       : Boolean;
    FLastTrick          : Boolean;
    FTakerPlay          : Boolean;
    FStrictSuitChecking : Boolean;
    FChangeDeck         : Boolean;
    FRandomDeck         : Boolean;
    FPartyRefCount      : Integer;
    FTrickRefCount      : Integer;
    FNextCardPos        : Integer;
    FDeckCount          : Integer;
    FDeckTopCard        : Integer;
    FTableOpenCards     : Integer;
    FTableCloseCards    : Integer;
    FShuffleCount       : Integer;
    FDelay              : Integer;
    FPlayerNoToPlay     : Integer;
    FCardsPerTrick      : Integer;
    FTopCardID          : Integer;
    FPrevCardID         : Integer;
    FFinishScore        : Integer;
    FFinishScoreDelta   : Integer;
    FTrickNo            : Integer;
    FTopCardPos         : Integer;
    FDeckTakeDelay      : Integer;
    FKnownCards         : Array [2..55] of Integer;
    FKnownValues        : Array [2..16] of Integer;
    FKnownSuites        : Array [1..5] of Integer;

    { PROCEDURAL }

    FAfterAddCard       : TESCardTableAddCardEvent;
    FAfterPrepareDeck   : TESCardTableNotifyEvent;
    FAfterTrickFinish   : TESCardTableNotifyEvent;
    FAfterDealingFinish : TESCardTableNotifyEvent;
    FAfterPartyFinish   : TESCardTableNotifyEvent;
    FAfterDealToTable   : TESCardTableAfterDealtoTableEvent;
    FBeforeAddCard      : TESCardTableBeforeAddCardEvent;
    FOnCardClick        : TESCardTableCardClickEvent;

    procedure SetNextCardPos(const Value: Integer);
    function GetPlayedCards(Index: Integer): Integer;
    procedure SetCardBottom(const Value: TESSingleCard);
    procedure SetCardLeft(const Value: TESSingleCard);
    procedure SetCardRight(const Value: TESSingleCard);
    procedure SetCardTop(const Value: TESSingleCard);
    procedure SetDeckType(const Value: TESDeckType);
    function GetCards(Index: Integer): TESSingleCard;
    procedure SetTableOpenCards(const Value: Integer);
    procedure SetTableCloseCards(const Value: Integer);
    procedure SetShuffleCount(const Value: Integer);
    procedure SetRandomCards(const Value: Boolean);
    procedure SetDelay(const Value: Integer);
    procedure SetCardsPerTrick(const Value: Integer);
    function GetDeckCards(Index: Integer): Integer;
    procedure SetDeckCards(Index: Integer; const Value: Integer);
    procedure SetShowBack(const Value: Boolean); override;
    procedure SetCardBack(const Value: TESBackType); override;
    function GetPlayerCount : Integer;
    procedure SetDeckTakeDelay(const Value: Integer);
    procedure SetCardDeck(const Value: TESCardDeck);
    procedure SetSprite(const Value: TESCustomSprite); override;
    function GetKnownCards(Index: Integer): Integer;
    function GetKnownValues(Index: Integer): Integer;
    function GetKnownSuites(Index: Integer): Integer;
    {$IFDEF NETENABLE}
    procedure SetNetManager(const Value: TESNetManager);
    {$ENDIF}
  protected
    procedure AddCardID(ID : Integer; AShowBack : Boolean; CardOwner : TESCardGroup = nil);
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure TimerUp(Sender : TObject);
    procedure Wait(Miliseconds : Integer);
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    procedure BackChange(Sender : TObject);

    { TABLE MANAGEMENT ROUTINES }

    property Cards[Index: Integer] : TESSingleCard read GetCards; default;
    procedure AddCard(ACard : TESSingleCard; AShowBack : Boolean; CardOwner : TESCardGroup = nil);
    procedure Clear(All : Boolean = False);
    property NextCardPos : Integer read FNextCardPos write SetNextCardPos;
    procedure ReDraw;

    { GAME MANAGEMENT ROUTINES }

    property DeckCards [Index : Integer] : Integer read GetDeckCards write SetDeckCards;
    property DeckCardsCount : Integer read FDeckCount;
    property Suit : TESSuitType read FSuit;
    property SuitBroken : Boolean read FSuitBroken;
    property PlayerNoToPlay : Integer read FPlayerNoToPlay write FPlayerNoToPlay;
    property LastTrick : Boolean read FLastTrick;
    property LastTaker : TESCardGroup read FLastTaker;
    property TrickNo : Integer read FTrickNo;
    property TopCardID : Integer read FTopCardID write FTopCardID;
    property PrevCardID : Integer read FPrevCardID write FPrevCardID;

    procedure ShowTakenCards;
    procedure HideTakenCards;
    procedure ClearTakenCards;
    procedure PrepareDeck;
    procedure Deal(PlayerCards : TESCardGroup); overload;
    procedure Deal(ChangeDealer : Boolean = False); overload;
    procedure DealToTable;
    procedure SendTableTo(PlayerCards : TESCardGroup);
    procedure ChangeDeckNext;
    procedure ChangeDeckPrev;
    procedure ChangeDeckRandom;
    procedure SendTopCardTo(PlayerCards : TESCardGroup);
    procedure SendCardFromDeckTo(PlayerCards : TESCardGroup);
    procedure StartPlay;
    function DrawCardFromDeck : Integer;
    function GetNextPlayerPos(PlayerPos : Integer) : Integer;
    function GetPrevPlayerPos(PlayerPos : Integer) : Integer;
    function FindHumanPlayer : TESCardGroup;

    { AI SUPPORT ROUTINES }

    procedure AddKnownID(ID : Integer);
    procedure ResetKnowns;
    property KnownCards [Index : Integer] : Integer read GetKnownCards;
    property KnownValues [Index : Integer] : Integer read GetKnownValues;
    property KnownSuites [Index : Integer] : Integer read GetKnownSuites;

    property RemainingCardsCount : Integer read FPartyRefCount;
    property PlayedCards[Index : Integer] : Integer read GetPlayedCards;
    function PlayedCardsCount: Integer;
    property FinishScoreDelta : Integer read FFinishScoreDelta write FFinishScoreDelta;

    function SmallestCardOwner : TESCardGroup;
    function BiggestCardOwner : TESCardGroup;
    function GetCardPoint(CardID : Integer) : Integer;
  published

    { INHERITED }

    property Empty default False;

    { EVENTS }

    property AfterAddCard : TESCardTableAddCardEvent read FAfterAddCard write FAfterAddCard;
    property BeforeAddCard : TESCardTableBeforeAddCardEvent read FBeforeAddCard write FBeforeAddCard;
    property AfterPrepareDeck : TESCardTableNotifyEvent read FAfterPrepareDeck write FAfterPrepareDeck;
    property AfterTrickFinish : TESCardTableNotifyEvent read FAfterTrickFinish write FAfterTrickFinish;
    property AfterPartyFinish : TESCardTableNotifyEvent read FAfterPartyFinish write FAfterPartyFinish;
    property AfterDealingFinish : TESCardTableNotifyEvent read FAfterDealingFinish write FAfterDealingFinish;
    property AfterDealToTable : TESCardTableAfterDealtoTableEvent read FAfterDealToTable write FAfterDealToTable;
    property OnCardClick : TESCardTableCardClickEvent read FOnCardClick write FOnCardClick;

    { UNIQUE PROPERTIES }

    property CardRight : TESSingleCard read FCardRight write SetCardRight;
    property CardBottom : TESSingleCard read FCardBottom write SetCardBottom;
    property CardLeft : TESSingleCard read FCardLeft write SetCardLeft;
    property CardTop : TESSingleCard read FCardTop write SetCardTop;
    property PlayerList : TESPlayerList read FPlayerList write FPlayerList;
    property PointList : TESPointList read FPointList write FPointList;
    {$IFDEF NETENABLE}
    property NetManager : TESNetManager read FNetManager write SetNetManager default nil;
    {$ENDIF}

    property Deck : TESCardDeck read FCardDeck write SetCardDeck default nil;
    property DeckType : TESDeckType read FDeckType write SetDeckType default dcSingle;
    property Trump : TESSuitType read FStrongSuit write FStrongSuit default stJoker;

    property StrictSuitChecking : Boolean read FStrictSuitChecking write FStrictSuitChecking default False;
    property RandomDeck : Boolean read FRandomDeck write FRandomDeck default False;
    property ChangeDeck : Boolean read FChangeDeck write FChangeDeck default False;
    property TakerPlay : Boolean read FTakerPlay write FTakerPlay default False;
    property RandomCards : Boolean read FRandomCards write SetRandomCards default False;
    property SuitChecking : Boolean read FSuitChecking write FSuitChecking default False;
    property DealAnimation : Boolean read FDealAnimation write FDealAnimation default True;
    property FinishScore : Integer read FFinishScore write FFinishScore default 0;
    property CardsPerTrick : Integer read FCardsPerTrick write SetCardsPerTrick default 1;
    property TakeDelay : Integer read FDelay write SetDelay default 500;
    property TableOpenCards : Integer read FTableOpenCards write SetTableOpenCards default 0;
    property TableCloseCards : Integer read FTableCloseCards write SetTableCloseCards default 0;
    property ShuffleCount : Integer read FShuffleCount write SetShuffleCount default 500;
    property DeckTakeDelay : Integer read FDeckTakeDelay write SetDeckTakeDelay default 0;
    property AutoPosDirection : TESTableDir read FAutoPosDirection write FAutoPosDirection default tdClockWise;
  end;

  {----------------------------------------------------------------------------}

  TESCardDeck = class(TESCustomCardControl)
  private

    { POINTERS }

    FCardFirst  : TESSingleCard;  { OWNED }
    FCardLast   : TESSingleCard;  { OWNED }
    FDeck       : TESArrayInt;    { OWNED }
    FTable      : TESCardTable;   { NIL }

    { ENUMERATED }

    FDeckType : TESDeckType;

    { PRIMITIVES }

    FShowLastCard : Boolean;
    FDeckEmpty    : Boolean;
    FDeckCount    : Integer;
    FDeckTopCard  : Integer;
    FDeckCardCount: Integer;
    FShuffleCount : Integer;

    { PROCEDURAL }

    FOnCardClick  : TESCardDeckCardClickEvent;
    FDealAnimation: Boolean;

    procedure SetShowLastCard(const Value: Boolean);
    procedure SetDeckType(const Value: TESDeckType);
    procedure SetDeckEmpty(const Value: Boolean);
    procedure SetDeckCount(const Value: Integer);
    procedure SetCardFirst(const Value: TESSingleCard);
    procedure SetCardLast(const Value: TESSingleCard);
    procedure SetShowBack(const Value: Boolean); override;
    procedure SetCardBack(const Value: TESBackType); override;
    property DeckCount : Integer read FDeckCount write SetDeckCount default 3;
    function GetCards(Index: Integer): Integer;
    procedure SetCards(Index: Integer; const Value: Integer);
    procedure SetCardsCount(const Value: Integer);
    function GetCardsCount: Integer;
  protected
    procedure Loaded; override;
    procedure RepaintCanvas(PaintAll : Boolean); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure PrepareDeck;
    function DrawCardFromDeck : Integer;
    procedure Deal(PlayerCards : TESCardGroup; CreateCards : Boolean = False; Count : Integer = 1);
    procedure DecreaseDeck;
    procedure IncreaseDeck;
    procedure SetDeckTo(Cards : TESCardGroup);
    property Cards[Index : Integer] : Integer read GetCards write SetCards; default;
    property CardsCount : Integer read GetCardsCount write SetCardsCount;
  published

    { INHERITED }

    property Empty default False;

    { EVENTS }

    property OnCardClick : TESCardDeckCardClickEvent read FOnCardClick write FOnCardClick;

    { UNIQUE PROPERTIES }

    property Table : TESCardTable read FTable write FTable default nil;
    property CardFirst : TESSingleCard read FCardFirst write SetCardFirst;
    property CardLast : TESSingleCard read FCardLast write SetCardLast;

    property DeckType : TESDeckType read FDeckType write SetDeckType default dcSingle;

    property ShowLastCard : Boolean read FShowLastCard write SetShowLastCard default True;
    property DeckEmpty : Boolean read FDeckEmpty write SetDeckEmpty default False;
    property DealAnimation : Boolean read FDealAnimation write FDealAnimation default True;
    property ShuffleCount : Integer read FShuffleCount write FShuffleCount default 500;
  end;

  { MISC ROUTINES } {----------------------------------------------------------}

  procedure InitializeImageList;
  procedure DestroyImageList;
  procedure QuickSort(var SortArray : TESSortArray);
  function GetCardBackType(ID : Integer) : TESBackType;
  function GetCardBackID(ACardBackType : TESBackType) : Integer;
  function GetCardSuit(CardID : Integer) : TESSuitType;
  function GetCardValue(CardID : Integer) : Integer;


  {----------------------------------------------------------------------------}

var
  ESImageList : Array[2..70] of TBitmap;

implementation

{$IFDEF DEFAULTRES}
{$R ESCARD.RES}
{$ELSE}
{$R RES256.RES}
{$ENDIF}

uses
  SysUtils, ESGameDlg;

var
  ESRefCount : Integer = 0;


{ TESPointItem }

constructor TESPointItem.Create(ACollection: TCollection);
begin
  inherited Create(ACollection);
  FCardID := 14;
  FPoints := 1;
end;

{ TESPointList }

function TESPointList.Add: TESPointItem;
begin
  Result := TESPointItem(inherited Add);
end;

constructor TESPointList.Create(AOwner: TESCustomCardControl;
  ACollectionItemClass: TCollectionItemClass);
begin
  FOwner := AOwner;
  inherited Create(AOwner, ACollectionItemClass);
end;

function TESPointList.GetItem(Index: Integer): TESPointItem;
begin
  Result := TESPointItem(inherited GetItem(Index));
end;

procedure TESPointList.SetItem(Index: Integer; Value: TESPointItem);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;

{ TESPlayerList }

function TESPlayerList.Add: TESPlayerItem;
begin
  Result := TESPlayerItem(inherited Add);
end;

constructor TESPlayerList.Create(AOwner: TESCustomCardControl;
  ACollectionItemClass: TCollectionItemClass);
begin
  inherited Create (AOwner, ACollectionItemClass);
  FOwner := AOwner;
end;

function TESPlayerList.GetItem(Index: Integer): TESPlayerItem;
begin
  Result := TESPlayerItem(inherited GetItem(Index));
end;

procedure TESPlayerList.SetItem(Index: Integer; Value: TESPlayerItem);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;
  
{ TESCustomCardControl }

constructor TESCustomCardControl.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FShowBack := True;
end;

procedure TESCustomCardControl.Lock;
begin
  if FLockCount = 0 then
    FBusy := True;
  Inc(FLockCount);
end;

procedure TESCustomCardControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if csDesigning in ComponentState then
  if Operation = opRemove then
    if AComponent = Sprite then
      Sprite := nil;
end;

procedure TESCustomCardControl.SetAutoEmpty(const Value: Boolean);
begin
  FAutoEmpty := Value;
end;

procedure TESCustomCardControl.SetCardBack(const Value: TESBackType);
begin
  FCardBack := Value;
end;

procedure TESCustomCardControl.SetShowBack(const Value: Boolean);
begin
  FShowBack := Value;
end;

procedure TESCustomCardControl.SetSprite(const Value: TESCustomSprite);
begin
  FSprite := Value;
end;

procedure TESCustomCardControl.UnLock;
begin
  Dec(FLockCount);
  if FLockCount = 0 then
  begin
    if Assigned(FAfterBusy) then
      FAfterBusy(Self);
    FBusy := False;
  end;
end;

{ TESSingleCard }

constructor TESSingleCard.Create(AOwner : TESCustomCardControl; APaintBitmap : TBitmap);
begin
  inherited Create;
  InitializeImageList;
  FArea.Left := AOwner.Left;
  FArea.Top := AOwner.Top;
  FArea.Bottom := FArea.Top + 96;
  FArea.Right := FArea.Left + 71;
  FSprite := AOwner.Sprite;
  if AOwner is TESCardGroup then
    FTable := (AOwner as TESCardGroup).Table;
  FOwner := AOwner;
  FCardBack := AOwner.CardBack;
  FShowBack := AOwner.ShowBack;
  FPaintBitmap := APaintBitmap;
  FFaceBitmap := ESImageList[14];
  FBackBitmap := ESImageList[GetCardbackID(FCardBack)];
  FID := 14;
  FValue := 14;
  FSuit := stClub;
  FValueKey := 1401;
  FCardColor := ccBlack;
end;

destructor TESSingleCard.Destroy;
begin
  FFaceBitmap := nil;
  FBackBitmap := nil;
  FPaintBitmap := nil;
  DestroyImageList;
  inherited Destroy;
end;

procedure TESSingleCard.SetEmpty(const Value: Boolean);
begin
  if FEmpty <> Value then
  begin
    FEmpty := Value;
    Draw(False);
  end;
end;

procedure TESSingleCard.SetID(const Value: Integer);
begin
  if FID <> Value then
  if (Value >= 2) and (Value <= 55) then
  begin
    FID := Value;
    FFaceBitmap := ESImageList[Value];
    FSuit := GetCardSuit(Value);
    FValue := GetCardValue(Value);
    case FSuit of
      stClub    : begin FCardColor := ccBlack; FSuitKey := 1; end;
      stDiamond : begin FCardColor := ccRed; FSuitKey := 2; end;
      stSpade   : begin FCardColor := ccBlack; FSuitKey := 3; end;
      stHeart   : begin FCardColor := ccRed; FSuitKey := 4; end;
      stJoker   : begin FCardColor := ccNone; FSuitKey := 5; end;
    end;
    FValueKey := FValue * 100  + FSuitKey;
    if (not FShowBack) and (not FEmpty) then
      Draw(False);
  end;
end;

procedure TESSingleCard.SetShowBack(const Value: Boolean);
begin
  if Value <> FShowBack then
  begin
    FShowBack := Value;
    Draw(False);
  end;
end;

procedure TESSingleCard.SetSuit(const Value: TESSuitType);
begin
  FSuit := Value;
  if (FValue > 14) and (Value <> stJoker) then
    FValue := 2;
  case Value of
    stClub    : ID := FValue;
    stDiamond : ID := FValue + 13;
    stSpade   : ID := FValue + 26;
    stHeart   : ID := FValue + 39;
    stJoker   :
      begin
        if FValue < 15 then
          FValue := 15;
        ID := FValue + 39;
      end;
  end;
end;

procedure TESSingleCard.SetValue(const Value: Integer);
begin
  if (Value >= 2) and (Value <= 16) then
  begin
    FValue := Value;
    if Value > 14 then
      Suit := stJoker
    else
    case Suit of
      stClub    : ID := Value;
      stDiamond : ID := Value + 13;
      stSpade   : ID := Value + 26;
      stHeart   : ID := Value + 39;
      stJoker   : ID := Value + 39;
    end;
  end;
end;

procedure TESSingleCard.Draw(PaintAll : Boolean = False);
var
  AMessage : TESInvalidateMessage;
  X, Y, W, H, A, B, ZZ : Integer;
  TotalCards : Integer;
  I : Integer;
  DeckCount : Integer;
  Tightness : Integer;
  OnlyCalcArea : Boolean;
begin
  X := 0;  Y := 0;  W := 0;  H := 0; A:=0; B:=0; ZZ := 0;

  { For TESCardGroup ----------------------------------------------------------}

  if Owner is TESCardGroup then
  begin
    TotalCards := (Owner as TESCardGroup).CardList.Count - 1;
    Tightness := (Owner as TESCardGroup).Tightness;
    OnlyCalcArea := (Owner as TESCardGroup).FOnlyCalcArea;

    case (Owner as TESCardGroup).CascadeSide of
      csRight :
      begin
        Y := 0; H := 96; B := 96;
        case (Owner as TESCardGroup).CascadeStyle of
          csNormal : begin X := Position * 76; W := TotalCards * 76 + 71; A := 71; end;
          csLoose  : begin X := Position * 38; W := TotalCards * 38 + 71; A := 38; end;
          csTight  : begin X := Position * Tightness; W := TotalCards * Tightness + 71; A := Tightness; end;
        end;
      end;
      csDown :
      begin
        X := 0; W := 71; A := 71;
        case (Owner as TESCardGroup).CascadeStyle of
          csNormal : begin Y := Position * 101; H := TotalCards * 101 + 96; B := 96; end;
          csLoose  : begin Y := Position * 50;  H := TotalCards * 50 + 96;  B := 50; end;
          csTight  : begin Y := Position * Tightness;  H := TotalCards * Tightness + 96;  B := Tightness; end;
        end;
      end;
    end;

    if not OnlyCalcArea then
    begin
      PaintBitmap.Height := H;
      PaintBitmap.Width := W;
    end;

    if Position < TotalCards then
    begin
      if ((Owner as TESCardGroup).CardList[Position + 1].Card.Empty) then
      begin
        case (Owner as TESCardGroup).CascadeStyle of
          csLoose  :
            case (Owner as TESCardGroup).CascadeSide of
              csRight :  A := 71;
              csDown  :  B := 96;
            end;
           csTight  :
           begin
             case (Owner as TESCardGroup).CascadeSide of
               csRight :  ZZ := 71 DIV TIGHTNESS - 1;
               csDown  :  ZZ := 96 DIV TIGHTNESS - 1;
             end;
             for I := Position + 1 to Position + 1 + ZZ do
             begin
               if I > TotalCards then
                 Break;
               if not (Owner as TESCardGroup).CardList[I].Card.Empty then
                   Break;
                if I = TotalCards then
                 case (Owner as TESCardGroup).CascadeSide of
                    csRight : A := 71;
                    csDown  : B := 96;
                 end
               else
                 case (Owner as TESCardGroup).CascadeSide of
                    csRight : Inc(A,Tightness);
                    csDown  : Inc(B,Tightness);
                 end;
             end;
           end;
         end;
      end;
    end
    else
    if Position = TotalCards then
    begin
      A := 71;
      B := 96;
    end;

    FArea.Left := X;
    FArea.Top := Y;
    FArea.Right := X + A;
    FArea.Bottom := Y + B;

    if OnlyCalcArea then
      Exit;

    if Empty then
    begin
      PaintBitmap.Canvas.FillRect(Rect(X, Y, X+A, Y+B));
      if (Owner as TESCardGroup).CascadeStyle <> csNormal then
        if Position > 0 then
          (Owner as TESCardGroup).CardList[Position - 1].Card.Draw(False);
    end
    else
    if ShowBack then
      PaintBitmap.Canvas.BrushCopy(Rect(X,Y,X+A,Y+B), FBackBitmap, Rect(0,0,A,B), FBackBitmap.TransparentColor)
    else
      PaintBitmap.Canvas.BrushCopy(Rect(X,Y,X+A,Y+B), FFaceBitmap, Rect(0,0,A,B), FFaceBitmap.TransparentColor);

    if (Owner as TESCardGroup).CascadeStyle = csNormal then
      case (Owner as TESCardGroup).CascadeSide of
        csRight : PaintBitmap.Canvas.FillRect(Rect(X+71,0, X+76, 96));
        csDown  : PaintBitmap.Canvas.FillRect(Rect(0,Y+96, 71, Y+101));
      end;

    if not PaintAll then
    begin
      AMessage.Msg := ESM_INVALIDREGION;
      AMessage.InvalidRegion := Rect(X, Y, W, H);
      AMessage.Sender := Self;
      Owner.Dispatch(AMessage);
    end
    else
      Owner.Invalidate;

    { SORTING }
    if (Position = TotalCards) and (not FEmpty) then
    if (Owner as TESCardGroup).SortStyle <> soNone then
      (Owner as TESCardGroup).Sort((Owner as TESCardGroup).SortStyle);

  end
  else

  { For TESCardDeck -----------------------------------------------------------}

  if Owner is TESCardDeck then
  begin
    DeckCount := (Owner as TESCardDeck).DeckCount;
    X := 0;
    Y := 0;

    if Position = 0 then
      case (Owner as TESCardDeck).DeckType of
        dcSingle :
        begin
          PaintBitmap.Width := 103;
          PaintBitmap.Height := 104;
        end;
        dcDouble :
        begin
          PaintBitmap.Width := 139; 
          PaintBitmap.Height := 96;
        end;
      end;

    if (Position = 0) and (not (Owner as TESCardDeck).DeckEmpty) and (not (Owner as TESCardDeck).ShowLastCard) then
      PaintBitmap.Canvas.FillRect(Rect(0, 0, 16, 96));

    if (Position = 0) and ((Owner as TESCardDeck).ShowLastCard) and (not (Owner as TESCardDeck).DeckEmpty) then
    begin
      if ShowBack then
        PaintBitmap.Canvas.BrushCopy(Rect(0,0,16,96), FBackBitmap, Rect(0,0,16,96), FFaceBitmap.TransparentColor)
      else
        PaintBitmap.Canvas.BrushCopy(Rect(0,0,16,96), FFaceBitmap, Rect(0,0,16,96), FFaceBitmap.TransparentColor);
    end
    else
    if (Position = 1) then
    begin
      if (Owner as TESCardDeck).DeckEmpty then
      begin
        PaintBitmap.Canvas.FillRect(Rect(0, 0, 16, 96));
        PaintBitmap.Canvas.BrushCopy(Rect(16, 0 , 16+71, 96), ESImageList[69], Rect(0,0,71,96),ESImageList[69].TransparentColor);
        PaintBitmap.Canvas.FillRect(Rect(16+71, 0, PaintBitmap.Width, PaintBitmap.Height));
        PaintBitmap.Canvas.FillRect(Rect(16, 96, PaintBitmap.Width, PaintBitmap.Height));
      end
      else
      begin
      A := X+16;
      B := Y;
      case (Owner as TESCardDeck).DeckType of
        dcSingle :
          for I := 0 to DeckCount do
          with PaintBitmap.Canvas do
          begin
            BrushCopy(Rect(A, B, A+4, B+96), FBackBitmap, Rect(0,0,4,96), FBackBitmap.TransparentColor);
            BrushCopy(Rect(A, B, A+71, B+2), FBackBitmap, Rect(0,0,71,2), FBackBitmap.TransparentColor);
            Inc(A, 4);
            Inc(B, 2);
          end;
        dcDouble :
          for I := 0 to DeckCount do
          with PaintBitmap.Canvas do
          begin
            BrushCopy(Rect(A, B, A+4, B+96), FBackBitmap, Rect(0,0,4,96), FBackBitmap.TransparentColor);
            Inc(A, 4);
          end;
      end;
      if ShowBack then
        PaintBitmap.Canvas.BrushCopy(Rect(A,B,A+71,B+96), FBackBitmap, Rect(0,0,71,96), FBackBitmap.TransparentColor)
      else
        PaintBitmap.Canvas.BrushCopy(Rect(A,B,A+71,B+96), FFaceBitmap, Rect(0,0,71,96), FFaceBitmap.TransparentColor);

      PaintBitmap.Canvas.FillRect(Rect(A+71, 0, PaintBitmap.Width, PaintBitmap.Height));
      PaintBitmap.Canvas.FillRect(Rect(16, B+96, PaintBitmap.Width, PaintBitmap.Height));
      end;
    end;

    FArea.Left := A;
    FArea.Top := B;
    FArea.Right := A + 71;
    FArea.Bottom := B+96;

    if not PaintAll then
    begin
      AMessage.Msg := ESM_INVALIDREGION;
      if Position = 0 then
        AMessage.InvalidRegion := Rect(0, 0, PaintBitmap.Width - 71, PaintBitmap.Height)
      else
        AMessage.InvalidRegion := Rect(A - (DeckCount *4 + 4) , 0, PaintBitmap.Width, PaintBitmap.Height);
      AMessage.Sender := Self;
      Owner.Dispatch(AMessage);
    end
    else
      Owner.Invalidate;
  end
  else

  { For TESCardTable ----------------------------------------------------------}

  if Owner is TESCardTable then
  begin
    case Position of
      0 : begin X := 24; Y := 60; end;
      1 : begin X :=  0; Y := 25; end;
      2 : begin X := 35; Y := 0;  end;
      3 : begin X := 60; Y := 35; end;
    end;
    FArea.Left := X;
    FArea.Top := Y;
    FArea.Right := X + 71;
    FArea.Bottom := Y + 96;
    if Empty then
      PaintBitmap.Canvas.FillRect(Rect(X, Y, X+71, Y+96))
    else
    if ShowBack then
      PaintBitmap.Canvas.BrushCopy(Rect(X, Y, X+71, Y+96), FBackBitmap, Rect(0, 0, 71, 96), FBackBitmap.TransparentColor)
    else
      PaintBitmap.Canvas.BrushCopy(Rect(X, Y, X+71, Y+96), FFaceBitmap, Rect(0, 0, 71, 96), FFaceBitmap.TransparentColor);
    if not PaintAll then
    begin
      AMessage.Msg := ESM_INVALIDREGION;
      AMessage.InvalidRegion := Rect(X, Y, X+71, Y+96);
      AMessage.Sender := Self;
      Owner.Dispatch(AMessage);
    end
    else
      Owner.Invalidate;
  end;
end;

procedure TESSingleCard.SetCardBack(const Value: TESBackType);
begin
  FCardBack := Value;
  FBackBitmap := ESImageList[GetCardBackID(Value)];
  if FShowBack and (not FEmpty) then
    Draw(False);
end;

procedure TESSingleCard.SetPosition(const Value: Integer);
begin
  FPosition := Value;
  Draw(False);
end;

function TESSingleCard.GetOwner: TPersistent;
begin
  Result := FOwner;
end;

procedure TESSingleCard.Play(TablePos : TESTablePos = tpAuto);
var
  X, Y, DX, DY : Integer;
begin
  if (Table <> nil) and (not Empty) then
  begin
    X := Owner.Left + FArea.Left;
    Y := Owner.Top + FArea.Top;
    DX := 0;
    DY := 0;
    case TablePos of
      tpAuto : ;
      tpBottom : Table.FNextCardPos := 0;
      tpLeft : Table.FNextCardPos := 1;
      tpTop : Table.FNextCardPos := 2;
      tpRight : Table.FNextCardPos := 3;
    end;

    case Table.FNextCardPos of
      0 : begin DX := 24; DY := 60; end;
      1 : begin DX :=  0; DY := 25; end;
      2 : begin DX := 35; DY := 0;  end;
      3 : begin DX := 60; DY := 35; end;
    end;
    DX := Table.Left + DX;
    DY := Table.Top + DY;
    Empty := True;
    if Sprite <> nil then
      Sprite.Move(X+1, Y+1, DX, DY, FFaceBitmap);
    if FOwner is TESCardGroup then
      Table.AddCard(Self, False, FOwner as TESCardGroup)
    else
      Table.AddCard(Self, False);
  end;
end;

procedure TESSingleCard.Assign(Dest: TPersistent);
begin
  if Dest is TESSingleCard then
  with Dest do
  begin
    CardBack := Self.FCardBack;
    ShowBack := Self.FShowBack;
    ID := Self.FID;
    Empty := Self.FEmpty;
  end
  else
    inherited;
end;

function TESSingleCard.NextColor: TESCardColor;
begin
  if FCardColor = ccBlack then
    Result := ccRed
  else
    Result := ccBlack;
end;

function TESSingleCard.NextValue: Integer;
begin
  Result := FValue + 1;
  if Result > 14 then
    Result := 2;
end;

function TESSingleCard.PrevValue: Integer;
begin
  Result := FValue - 1;
  if Result < 2 then
    Result := 14;
end;

function TESSingleCard.NextID: Integer;
var
  I : Integer;
begin
  I := FID;
  Inc(I);
  if I > 55 then
    I := 2;
  Result := I;
end;

function TESSingleCard.PrevID: Integer;
var
  I : Integer;
begin
  I := FID;
  Dec(I);
  if I < 2 then
    I := 55;
  Result := I;
end;

function TESSingleCard.GetLeft: Integer;
begin
  Result := Owner.Left + FArea.Left;
end;

function TESSingleCard.GetTop: Integer;
begin
  Result := Owner.Top + FArea.Top;
end;

function TESSingleCard.GetHeight: Integer;
begin
  Result := FArea.Bottom - FArea.Top;
end;

function TESSingleCard.GetWidth: Integer;
begin
  Result := FArea.Right - FArea.Left;
end;

{ TESCardItem }

constructor TESCardItem.Create(ACollection: TCollection);
begin
  inherited Create(ACollection);
  FCard := TESSingleCard.Create(TESCardList(ACollection).Owner,
    TESCardList(ACollection).Owner.PaintBitmap);
  FCard.Position := Self.Index;
end;

destructor TESCardItem.Destroy;
begin
  FCard.Free;
  inherited Destroy;
end;

procedure TESCardItem.SetCard(const Value: TESSingleCard);
begin
  FCard.Assign(Value);
end;

{ TESCardList }

function TESCardList.Add: TESCardItem;
begin
  TESCardGroup(Owner).CalcAutoTight;
  Result := TESCardItem(inherited Add);
end;

procedure TESCardList.Clear;
begin
  inherited;
  if not (csDesigning in Owner.ComponentState) then
    Owner.RepaintCanvas(False);
end;

constructor TESCardList.Create(AOwner: TESCustomCardControl;
  ACollectionItemClass: TCollectionItemClass);
begin
  inherited Create(AOwner, ACollectionItemClass);
  FOwner := AOwner;
end;

function TESCardList.GetItem(Index: Integer): TESCardItem;
begin
  Result := TESCardItem(inherited GetItem(Index));
end;

procedure TESCardList.SetItem(Index: Integer; Value: TESCardItem);
begin
  inherited SetItem(Index, TCollectionItem(Value));
end;

procedure TESCardList.Update(Item: TCollectionItem);
var
  I : Integer;
begin
  TESCardGroup(Owner).FCardCount := Count;
  if csDesigning in Owner.ComponentState then
  if Count = 0 then
  begin
    Owner.PaintBitmap.Canvas.FillRect(Rect(0,0,Owner.Width, Owner.Height));
    Owner.Invalidate;
  end
  else
    for I := 0 to Count - 1 do
      Items[I].Card.Position := Items[I].Index;
  if not (csLoading in TESCardGroup(Owner).ComponentState) then
    if Assigned(TESCardGroup(Owner).FAfterUpdate) then
      TESCardGroup(Owner).FAfterUpdate(TESCardGroup(Owner));
end;

{ TESCardGroup }

constructor TESCardGroup.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  SetLength(FSavedCards,0);
  FShowOnlyPointCards := True;
  PaintBitmap.Width := 71;
  PaintBitmap.Height := 96;
  Width := PaintBitmap.Width;
  Height := PaintBitmap.Height;
  FTightness := 16;
  SetLength(FNonEmptyCards, 0);
  FCardCursor := crHandPoint;
  FController := ctHuman;
  Empty := False;
  SetLength(FTakenCards, 0);
  FCardList := TESCardList.Create(Self, TESCardItem);
end;

destructor TESCardGroup.Destroy;
begin
  FCardList.Free;
  FSavedCards := nil;
  FNonEmptyCards := nil;
  FTakenCards := nil;
  inherited Destroy;
end;

function TESCardGroup.GetCards(Index: Integer): TESSingleCard;
begin
  Result := nil;
  if (Index >= 0) and (Index < CardList.Count) then
    if CardList[Index].Card <> nil then
      Result := CardList[Index].Card;
end;

function TESCardGroup.NonEmptyCardsCount: Integer;
var
  I : Integer;
begin
  SetLength(FNonEmptyCards, 0);
  for I := 0 to CardList.Count - 1 do
    if not CardList[I].Card.Empty then
    begin
      SetLength(FNonEmptyCards, Length(FNonEmptyCards) + 1);
      FNonEmptyCards[Length(FNonEmptyCards) -1] := CardList[I].Card.Position;
    end;
  Result := Length(FNonEmptyCards);
end;

function TESCardGroup.GetNonEmptyCards(Index: Integer): TESSingleCard;
begin
  Result := nil;
  if (Index >=0) and (Index < Length(FNonEmptyCards)) then
    Result :=  CardList[FNonEmptyCards[Index]].Card;
end;

function TESCardGroup.FindRandomCardPos: Integer;
begin
  Randomize;
  if NonEmptyCardsCount > 0 then
    Result := FNonEmptyCards[Random(Length(FNonEmptyCards))]
  else
    Result := -1;
end;

function TESCardGroup.FindRandomCard: TESSingleCard;
var
  A : Integer;
begin
  A := FindRandomCardPos;
  if A >= 0 then
    Result := CardList[A].Card
  else
    Result := nil;
end;

procedure TESCardGroup.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  I : Integer;
begin
  inherited;
  if CardCursor = crDefault then Exit;
  I := FindMousePos(X, Y);
  if I >= 0 then
  begin
    if CardList[I].Card.Empty then
      Cursor := crDefault
    else
      Cursor := CardCursor;
  end;
end;


procedure TESCardGroup.RepaintCanvas(PaintAll : Boolean);
var
  I : Integer;
begin
  if (FCardList.Count = 0) then 
  begin
    PaintBitmap.Canvas.FillRect(Rect(0,0,PaintBitmap.Width, PaintBitmap.Height));
    Invalidate;
  end
  else
  for I := 0 to CardList.Count -1 do
  begin
    if CardList[I].Card <> nil then
      CardList[I].Card.Draw(PaintAll);
  end;
end;

procedure TESCardGroup.SetCardBack(const Value: TESBackType);
var
  I : Integer;
begin
  FCardBack := Value;
  if CardList <> nil then
    if CardList.Count > 0 then
      for I := 0 to CardList.Count - 1 do
          CardList[I].Card.CardBack := Value;
end;

procedure TESCardGroup.SetCascadeSide(const Value: TESCascadeSide);
begin
  FCascadeSide := Value;
  RepaintCanvas(True);
end;

procedure TESCardGroup.SetCascadeStyle(const Value: TESCascadeStyle);
begin
  FCascadeStyle := Value;
  if Value <> csTight then
    AutoTight := False;
  RepaintCanvas(True);
end;

procedure TESCardGroup.SetShowBack(const Value: Boolean);
var
  I : Integer;
begin
  FShowBack := Value;
  if CardList <> nil then
    if CardList.Count > 0 then
      for I := 0 to CardList.Count - 1 do
        CardList[I].Card.ShowBack := Value;
end;

procedure TESCardGroup.SetCardTable(const Value: TESCardTable);
var
  I : Integer;
begin
  FTable := Value;
  if CardList.Count > 0 then
    for I := 0 to CardList.Count - 1 do
      if CardList[I].Card <> nil then
        CardList[I].Card.Table := Value;
end;

procedure TESCardGroup.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if csDesigning in ComponentState then
  if Operation = opRemove then
    if AComponent is TESCardTable then
    begin
      if AComponent = FTable then
        FTable := nil;
    end
    else
    if AComponent is TLabel then
    begin
      if AComponent = FNameLabel then
        FNameLabel := nil;
      if AComponent = FScoreLabel then
        FScoreLabel := nil;
    end;
end;

procedure TESCardGroup.Play(Pos: Integer; TablePos : TESTablePos = tpAuto);
begin
  if (FPlayDelay > 0) and (FController = ctComputer) then
    FTable.Wait(FPlayDelay);
  if (Pos >=0) and (Pos < FCardList.Count) then
    CardList[Pos].Card.Play(TablePos);
end;

procedure TESCardGroup.SetSprite(const Value: TESCustomSprite);
var
  I : Integer;
begin
  FSprite := Value;
  if CardList.Count > 0 then
    for I := 0 to CardList.Count - 1 do
      if CardList[I].Card <> nil then
        CardList[I].Card.Sprite := Value;
end;

procedure TESCardGroup.Loaded;
var
  I : Integer;
begin
  inherited;
  if AutoEmpty then
    if not (csDesigning in ComponentState) then
      for I := 0 to FCardList.Count - 1 do
        FCardList[I].Card.Empty := True;
  if not (csDesigning in ComponentState) then
    SaveCards;
end;

procedure TESCardGroup.SetTightness(const Value: Integer);
var
  T : Integer;
begin
  T := Value;
  if Value < 0 then
    T := 0;
  if Value > 70 then
    T := 70;
  FTightness := T;
  RepaintCanvas(False);
end;

procedure TESCardGroup.SetAutoTight(const Value: Boolean);
begin
  FAutoTight := Value;
  if Value then
  begin
    CascadeStyle := csTight;
    AutoSize := False;
  end
  else
    Tightness := 16;
end;

procedure TESCardGroup.SetSortStyle(const Value: TESSortStyle);
begin
  FSortStyle := Value;
  if Value <> soNone then
    Sort(Value);
end;

procedure TESCardGroup.SetRandomCards(const Value: Boolean);
var
  I : Integer;
begin
  FRandomCards := Value;
  if Value and ((csDesigning in ComponentState) or (not FAutoEmpty)) then
  begin
    Randomize;
    for I := 0 to CardList.Count - 1 do
      CardList[I].Card.ID := Random(52) + 2;
  end
  else
  if csDesigning in ComponentState then
    for I := 0 to CardList.Count - 1 do
      CardList[I].Card.ID :=14;
end;

function TESCardGroup.FindIDPos(ID: Integer): Integer;
var
  I : Integer;
begin
  Result := -1;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.ID = ID) and (not CardList[I].Card.Empty)then
    begin
      Result := I;
      Break;
    end;
end;

function TESCardGroup.FindSuitPos(Suit: TESSuitType): Integer;
var
  I : Integer;
begin
  Result := -1;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.Suit = Suit) and (not CardList[I].Card.Empty)then
    begin
      Result := I;
      Break;
    end;
end;

function TESCardGroup.FindValuePos(Value: Integer): Integer;
var
  I : Integer;
begin
  Result := -1;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.Value = Value) and (not CardList[I].Card.Empty)then
    begin
      Result := I;
      Break;
    end;
end;

procedure TESCardGroup.PlayCard;
var
  Position : Integer;
  TablePos : TESTablePos;
begin
  if (FController = ctComputer) then
  begin
    Position := FindRandomCardPos;
    TablePos := FTablePlayPos;
    if Assigned(FBeforePlay) then
      FBeforePlay(Self, Position, TablePos);
    if (Position >=0) and (Position < FCardList.Count) then
      Play(Position, TablePos);
  end
  else
    Abort;
end;

procedure TESCardGroup.SetDealer(const Value: Boolean);
var
  I : Integer;
begin
  if (csDesigning in ComponentState) and Value then
    for I := 0 to TForm(Owner).ControlCount - 1 do
      if TForm(Owner).Controls[I] is TESCardGroup then
        (TForm(Owner).Controls[I] as TESCardGroup).FDealer := False;
  FDealer := Value;
end;

procedure TESCardGroup.Clear;
var
  I : Integer;
begin
  for I := 0 to CardList.Count - 1 do
      CardList[I].Card.Empty := True;
end;

function TESCardGroup.GetTakenCards(Index: Integer): Integer;
begin
  Result := FTakenCards[Index]
end;

procedure TESCardGroup.SetTakenCards(Index: Integer; const Value: Integer);
begin
  FTakenCards[Index] := Value;
end;

procedure TESCardGroup.AddToTakenCards(CardIDArray: TESArrayInt);
var
  A, I, L1, L2: Integer;
begin
  A := 0;
  L1 := Length(FTakenCards);
  L2 := Length(CardIDArray);
  SetLength(FTakenCards, L1 + L2);
  for I := 0 to L2 - 1 do
  begin
    FTakenCards[L1 + I] := CardIDArray[I];
    if FTable <> nil then
      A := A + Table.GetCardPoint(CardIDArray[I]);
  end;
  Score := FScore + A;
  if Assigned(FAfterCardTake) then
    FAfterCardTake(Self);
end;

procedure TESCardGroup.ClearTakenCards;
begin
  SetLength(FTakenCards, 0);
end;

procedure TESCardGroup.ShowTakenCards;
var
  I : Integer;
begin
  if Table<>nil then
  begin
    Empty := True;
    BeginUpdate;
    try
      FOldSortStyle := FSortStyle;
      FSortStyle := soNone;
      Application.ProcessMessages;
      FOldCount := CardList.Count;
      FOldCascadeStyle := FCascadeStyle;
      FOldShowBack := FShowBack;

      CardList.Clear;
      if FShowAutoTight then
        AutoTight := True
      else
        CascadeStyle := csTight;
      ShowBack := False;
      for I := 0 to Length(FTakenCards) - 1 do
        if FShowOnlyPointCards then
        begin
          if (Table.GetCardPoint(FTakenCards[I]) <> 0) then
           with CardList.Add do
              Card.ID := FTakenCards[I];
        end
        else
          with CardList.Add do
            Card.ID := FTakenCards[I];
      Application.ProcessMessages;
      if FShowSortStyle <> soNone then
        Sort(FShowSortStyle);
    finally
      EndUpdate;
      Empty := False;
    end;
  end;
end;

procedure TESCardGroup.HideTakenCards;
var
  I : Integer;
begin
  if Table <> nil then
  begin
    Empty := True;
    BeginUpdate;
    try
      Application.ProcessMessages;
      CardList.Clear;
      ShowBack := FOldShowBack;
      if FShowAutoTight then
        AutoTight := False;
      CascadeStyle := FOldCascadeStyle;
      for I := 0 to FOldCount - 1  do
      begin
        with CardList.Add do
          Card.Empty := True;
        Application.ProcessMessages;
      end;
      FSortStyle := FOldSortStyle;
    finally
      EndUpdate;
      Empty := False;
    end;
  end;
end;

function TESCardGroup.TakenCardsCount: Integer;
begin
  Result := Length(FTakenCards);
end;

procedure TESCardGroup.SetScore(const Value: Integer);
begin
  if Value <> FScore then
  begin
    FScore := Value;
    if FScoreLabel <> nil then
      FScoreLabel.Caption := IntToStr(FScore);
    if Assigned(FAfterScoreChange) then
      FAfterScoreChange(Self);
  end;
end;

procedure TESCardGroup.SetPlayerName(const Value: String);
begin
  FPlayerName := Value;
  if FNameLabel <> nil then
    FNameLabel.Caption := Value;
end;

procedure TESCardGroup.SetNameLabel(const Value: TLabel);
begin
  FNameLabel := Value;
  if Value <> nil then
    Value.Caption := FPlayerName;
end;

procedure TESCardGroup.SetScoreLabel(const Value: TLabel);
begin
  FScoreLabel := Value;
  if Value <> nil then
    Value.Caption := IntToStr(FScore);
end;

function TESCardGroup.TakenCardsPoints: Integer;
var
  I, A : Integer;
begin
  if FTable <> nil then
  begin
    A := 0;
    for I := 0 to Length(FTakenCards) - 1 do
      A := A + FTable.GetCardPoint(FTakenCards[I]);
    Result := A;
  end
  else
    Result := -1;
end;

procedure TESCardGroup.Sort(ASortStyle : TESSortStyle);
var
  CardArray : TESSortArray;
  I : Integer;
begin
  if FCardList.Count > 0 then
  begin
    BeginUpdate;
    try
      SetLength(CardArray, FCardList.Count);

      for I := 0 to Length(CardArray) - 1 do
        CardArray[I].Data := CardList[I].Card.ID;

      for I := 0 to Length(CardArray) - 1 do
        case ASortStyle of
          soSuit :
            CardArray[I].Key := CardList[I].Card.ID;
          soValue :
            CardArray[I].Key := CardList[I].Card.ValueKey;
        end;

      QuickSort(CardArray);

      for I := 0 to Length(CardArray) - 1 do
        CardList[I].Card.ID := CardArray[I].Data;

      CardArray := nil;
    finally
      EndUpdate;
      Redraw;
    end;
  end;
end;

function TESCardGroup.FindMaxSuitPos(Suit: TESSuitType): Integer;
var
  I, C : Integer;
begin
  Result := -1;
  C := 0;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.Suit = Suit) and (not CardList[I].Card.Empty)then
      if CardList[I].Card.Value > C then
      begin
        C := CardList[I].Card.Value;
        Result := I;
      end;
end;

function TESCardGroup.FindMinSuitPos(Suit: TESSuitType): Integer;
var
  I, C : Integer;
begin
  Result := -1;
  C := 100;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.Suit = Suit) and (not CardList[I].Card.Empty)then
      if CardList[I].Card.Value < C then
      begin
        C := CardList[I].Card.Value;
        Result := I;
      end;
end;

function TESCardGroup.FindMaxValuePos : Integer;
var
  I, C : Integer;
begin
  Result := -1;
  C := 0;
  for I := 0 to CardList.Count - 1 do
    if not CardList[I].Card.Empty then
      if CardList[I].Card.Value > C then
      begin
        Result := I;
        C := CardList[I].Card.Value;
      end;
end;

function TESCardGroup.FindMinValuePos : Integer;
var
  I, C : Integer;
begin
  Result := -1;
  C := 100;
  for I := 0 to CardList.Count - 1 do
    if not CardList[I].Card.Empty then
      if CardList[I].Card.Value < C then
      begin
        Result := I;
        C := CardList[I].Card.Value;
      end;
end;

function TESCardGroup.FindMaxSuitPosInvert(Suit : TESSuitType) : Integer;
var
  I, C : Integer;
begin
  Result := -1;
  C := 0;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.Suit <> Suit) and (not CardList[I].Card.Empty)then
      if CardList[I].Card.Value > C then
      begin
        C := CardList[I].Card.Value;
        Result := I;
      end;
end;

function TESCardGroup.FindMinSuitPosInvert(Suit: TESSuitType): Integer;
var
  I, C : Integer;
begin
  Result := -1;
  C := 100;
  for I := 0 to CardList.Count - 1 do
    if (CardList[I].Card.Suit <> Suit) and (not CardList[I].Card.Empty)then
      if CardList[I].Card.Value < C then
      begin
        C := CardList[I].Card.Value;
        Result := I;
      end;
end;


function TESCardGroup.FindReservedPos: Integer;
var
  J : Integer;
begin
  Result := FCardList.Count - 1;
  for J := 0 to FCardList.Count - 1 do
    if (FCardList[J].Card.Empty) then
    begin
      Result := J;
      Break;
    end;
end;

procedure TESCardGroup.SetPlayDelay(const Value: Integer);
begin
  if Value >=0 then
    FPlayDelay := Value;
end;

function TESCardGroup.FindMousePos(X, Y: Integer): Integer;
var
  I : Integer;
begin
  Result := -1;
  FOnlyCalcArea := True;
  try
    RepaintCanvas(False);
  finally
    FOnlyCalcArea := False;
  end;
  for I := 0 to FCardList.Count -1 do
    if  (X > FCardList[I].Card.FArea.Left) and (X < FCardList[I].Card.FArea.Right) and
        (Y > FCardList[I].Card.FArea.Top)  and (Y < FCardList[I].Card.FArea.Bottom) then
        begin
          Result := I;
          Break;
        end;
end;

procedure TESCardGroup.SwitchPos(A, B: Integer);
var
  T : Integer;
  F : Boolean;
begin
  if (A >= 0) and (A < FCardList.Count) and
     (B >= 0) and (B < FCardList.Count) then
     begin
       T := FCardList[A].Card.ID;
       F := FCardList[A].Card.Empty;
       FCardList[A].Card.ID := FCardList[B].Card.ID;
       FCardList[A].Card.Empty := FCardList[B].Card.Empty;
       FCardList[B].Card.ID := T;
       FCardList[B].Card.Empty := F;
     end;
end;

procedure TESCardGroup.Click;
var
  Position : Integer;
  PlayIt : Boolean;
  TablePos : TESTablePos;
  CP : TPoint;
begin
  //BUG: If there is no table then OnCardClick will not fire
  //REPORTED: 30-08-99 by Craig EDGAR
  //FIXED: 02-09-99 by Ecmel ERCAN
  inherited;
  if (FTable <> nil) then
  begin
    if (not FTable.Busy) then
    begin
      CP := ScreenToClient(Mouse.CursorPos);
      Position := FindMousePos(CP.X, CP.Y);
      TablePos := FTablePlayPos;
      Cursor := crDefault;
      PlayIt := False;
      if (Position >=0) and (Position < CardList.Count) then
        if Assigned(OnCardClick) then
          OnCardClick(Self, FCardList[Position].Card, Position, PlayIt, TablePos);
      if (PlayIt) and (Position >=0) and (Position < FCardList.Count) then
        if not FCardList[Position].Card.Empty then
          Play(Position, TablePos);
    end;
  end
  else
  begin
      CP := ScreenToClient(Mouse.CursorPos);
      Position := FindMousePos(CP.X, CP.Y);
      TablePos := FTablePlayPos;
      Cursor := crDefault;
      PlayIt := False;
      if (Position >=0) and (Position < CardList.Count) then
        if Assigned(OnCardClick) then
          OnCardClick(Self, FCardList[Position].Card, Position, PlayIt, TablePos);
  end;
end;

procedure TESCardGroup.InsertPos(A, B: Integer);
var
  I : Integer;
  ID : Integer;
  F : Boolean;
  IDS : array [0..100] of Integer;
  FS : array [0..100] of Boolean;
begin
  if (A >= 0) and (A < FCardList.Count) and
     (B >= 0) and (B < FCardList.Count) then
     begin
       ID := FCardList[B].Card.ID;
       F := FCardList[B].Card.Empty;
       if A < B then
         for I := A to B do
         begin
           IDS[I]:= FCardList[I].Card.ID;
           FS[I] := FCardList[I].Card.Empty;
         end
       else
         for I := B to A  do
         begin
           IDS[I]:= FCardList[I].Card.ID;
           FS[I] := FCardList[I].Card.Empty;
         end;

       if A < B then
         for I := A + 1 to B do
         begin
           FCardList[I].Card.ID := IDS[I - 1];
           FCardList[I].Card.Empty := FS[I - 1];
         end
       else
         for I := B to A - 1 do
         begin
           FCardList[I].Card.ID := IDS[I + 1];
           FCardList[I].Card.Empty := FS[I + 1];
         end;

       FCardList[A].Card.ID := ID;
       FCardList[A].Card.Empty := F;
     end;
end;

procedure TESCardGroup.DragDrop(Source: TObject; X, Y: Integer);
begin
  TESCardGroup(Source).BeginUpdate;
  BeginUpdate;
  try
    inherited;
  finally
    TESCardGroup(Source).RepaintCanvas(False);
    TESCardGroup(Source).Redraw;
    TESCardGroup(Source).EndUpdate;
    RepaintCanvas(False);
    Redraw;
    EndUpdate;
  end;
end;

procedure TESCardGroup.LoadCards;
var
  I : Integer;
begin
  BeginUpdate;
  try
    FCardList.Clear;
    for I := 0 to Length(FSavedCards) - 1 do
    with FCardList.Add do
    begin
      Card.Empty := FSavedCards[I].Empty;
      Card.ID := FSavedCards[I].ID;
      Card.ShowBack := FSavedCards[I].ShowBack;
    end;
  finally
    EndUpdate;
    ReDraw;
  end;
end;

procedure TESCardGroup.SaveCards;
var
  I : Integer;
begin
  SetLength(FSavedCards, FCardList.Count);
  for I := 0 to FCardList.Count - 1 do
  with FSavedCards[I] do
  begin
    ID := FCardList[I].Card.FID;
    ShowBack := FCardList[I].Card.FShowBack;
    Empty := FCardList[I].Card.FEmpty;
  end;
end;

procedure TESCardGroup.Reset(ClearAlso : Boolean = False);
begin
  LoadCards;
  if ClearAlso then
    Clear;
end;

function TESCardGroup.LastCard: TESSingleCard;
begin
  if FCardList.Count > 0 then
    Result := FCardList[FCardList.Count - 1].Card
  else
    Result := nil;
end;

procedure TESCardGroup.CalcAutoTight;
begin
  if FAutoTight and (FCardList.Count > 0) then
  begin
    if FCascadeSide = csRight then
       Tightness := (Width - 71) div FCardList.Count
     else
       Tightness := (Height - 96) div FCardList.Count;
  end;
end;

procedure TESCardGroup.Resize;
begin
  inherited;
  CalcAutoTight;
end;

procedure TESCardGroup.DeleteLastCard;
begin
  BeginUpdate;
  try
    FCardList[FCardList.Count - 1].Free;
  finally
    RepaintCanvas(False);
    EndUpdate;
    Redraw;
  end;
end;

{ TESCardTable }

procedure TESCardTable.AddCard(ACard: TESSingleCard; AShowBack : Boolean; CardOwner : TESCardGroup = nil);
var
  Accept : Boolean;
  SuitExists : Boolean;
begin
  Lock;
  try
    SuitExists := False;

    if FSuitChecking then
    if PlayedCardsCount = 0 then
      FSuit := ACard.Suit;

    if FSuitChecking then
    if CardOwner <> nil then
      SuitExists := (CardOwner.FindSuitPos(FSuit) >=0)
    else
      SuitExists := False;

    Accept := True;

    if FSuitChecking then
    if (FStrictSuitChecking) and (PlayedCardsCount = 0) and (not FSuitBroken) and (ACard.Suit = FStrongSuit) then
      Accept := False;

    if FSuitChecking and (CardOwner <> nil) and (PlayedCardsCount > 0) then
      if SuitExists and (ACard.Suit <> FSuit) then
        Accept := False;

    if FSuitChecking then
    if Accept and (PlayedCardsCount > 0) and (ACard.Suit = FStrongSuit) then
      FSuitBroken := True;

    if Assigned(FBeforeAddCard) then
      FBeforeAddCard(Self, ACard, SuitExists, Accept);

    if not Accept then
    begin
      if CardOwner <> nil then
      begin
        Sprite.Visible := True;
        if FDelay > 0 then
          Wait(FDelay);
        if Sprite <> nil then
          Sprite.MoveBack;
        CardOwner.CardList[ACard.Position].Card.Empty := False;
      end;
    end
    else
    begin
      AddCardID(ACard.ID, AShowBack, CardOwner);
      FPlayerNoToPlay := GetNextPlayerPos(FPlayerNoToPlay);
      Inc(FTrickRefCount);
      if FTrickRefCount = FCardsPerTrick then
      begin
        Inc(FTrickNo);
        FTrickRefCount := 0;
        if FChangeDeck then
          ChangeDeckNext;
        if Assigned(FAfterTrickFinish) then
          FAfterTrickFinish(Self);
      end;

      if FPlayerList.Count > 0 then
      if FPlayerList[FPlayerNoToPlay].CardGroup <> nil then
        FPlayerList[FPlayerNoToPlay].CardGroup.PlayCard;
    end;
  finally
    Unlock;
  end;
end;

procedure TESCardTable.AddCardID(ID: Integer; AShowBack: Boolean; CardOwner : TESCardGroup = nil);
begin
  Lock;
  try
    if Empty then
      Empty := False;
    if not AShowBack then
      AddKnownID(ID);
    case FNextCardPos of
      0 : begin
            CardBottom.ID := ID;
            CardBottom.ShowBack := AShowBack;
            CardBottom.CardOwner := CardOwner;
            if CardBottom.Empty then
              CardBottom.Empty := False;
          end;
      1 : begin
            CardLeft.ID := ID;
            CardLeft.ShowBack := AShowBack;
            CardLeft.CardOwner := CardOwner;
            if CardLeft.Empty then
              CardLeft.Empty := False;
          end;
      2 : begin
            CardTop.ID := ID;
            CardTop.ShowBack := AShowBack;
            CardTop.CardOwner := CardOwner;
            if CardTop.Empty then
              CardTop.Empty := False;
          end;
      3 : begin
            CardRight.ID := ID;
            CardRight.ShowBack := AShowBack;
            CardRight.CardOwner := CardOwner;
            if CardRight.Empty then
              CardRight.Empty := False;
          end;
    end;

    FPrevCardID := FTopCardID;
    FTopCardID := ID;

    FTopCardPos := FNextCardPos;

    if FAutoPosDirection = tdClockWise then
    begin
      Inc(FNextCardPos);
      if FNextCardPos > 3 then
        FNextCardPos := 0;
    end
    else
    begin
      Dec(FNextCardPos);
      if FNextCardPos < 0 then
        FNextCardPos := 3;
    end;
    SetLength(FPlayedCards, Length(FPlayedCards) + 1);
    FPlayedCards[Length(FPlayedCards) - 1] := ID;
    Dec(FPartyRefCount);
    if FPartyRefCount - FCardsPerTrick < 0 then
      FLastTrick := True;
    if Assigned(FAfterAddCard) then
      FAfterAddCard(Self, PlayedCardsCount, FTopCardPos, Cards[FTopCardPos], FTopCardID, FPrevCardID, (CardOwner <> nil));

  finally
    Unlock;
  end;
end;

procedure TESCardTable.Clear(All : Boolean = False);
var
  I : Integer;
begin
  Lock;
  try
    FTopCardPos := -1;
    SetLength(FPlayedCards, 0);
    CardBottom.Empty := True;
    CardLeft.Empty := True;
    CardTop.Empty := True;
    CardRight.Empty := True;
    FNextCardPos := 3;
    FTopCardID := -1;
    FPrevCardID := -2;
    FSuit := stJoker;
    if All then
      for I := 0 to FPlayerList.Count - 1 do
        if FPlayerList[I].CardGroup <> nil then
        begin
          FPlayerList[I].CardGroup.Empty := True;
          FPlayerList[I].CardGroup.Clear;
          FPlayerList[I].CardGroup.ClearTakenCards;
          FPlayerList[I].CardGroup.Empty := False;
        end;
  finally
    Unlock;
  end;
end;

constructor TESCardTable.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FTimer := TTimer.Create(Self);
  FTimer.Enabled := False;
  FTimer.OnTimer := TimerUp;
  FWaiting := False;

  Randomize;
  FLockCount := 0;
  FPointList := TESPointList.Create(Self, TESPointItem);
  FPlayerList := TESPlayerList.Create(Self, TESPlayerItem);
  FTopCardID := -1;
  FPrevCardID := -2;
  FDeckCount := 52;
  PaintBitmap.Width := 131;
  PaintBitmap.Height := 156;
  FCardBottom := TESSingleCard.Create(Self, PaintBitmap);
  FCardBottom.Position := 0;
  FCardBottom.ShowBack := False;
  FCardLeft := TESSingleCard.Create(Self, PaintBitmap);
  FCardLeft.Position := 1;
  FCardLeft.ShowBack := False;
  FCardTop := TESSingleCard.Create(Self, PaintBitmap);
  FCardTop.Position := 2;
  FCardTop.ShowBack := False;
  FCardRight := TESSingleCard.Create(Self, PaintBitmap);
  FCardRight.Position := 3;
  FCardRight.ShowBack := False;
  SetLength(FPlayedCards, 0);
  SetLength(FDeck, 0);
  Width := PaintBitmap.Width;
  Height := PaintBitmap.Height;
  FShuffleCount := 500;
  FDealAnimation := True;
  FDelay := 500;
  FPlayerNoToPlay := 0;
  FTrickRefCount := 0;
  FPartyRefCount := 0;
  FCardsPerTrick := 1;
  Empty := False;
  FSuit := stJoker;
  FTopCardPos := -1;
  ResetKnowns;
end;

destructor TESCardTable.Destroy;
begin
  FTimer.Free;
  FCardLeft.Free;
  FCardRight.Free;
  FCardBottom.Free;
  FCardTop.Free;
  FPlayedCards := nil;
  FDeck := nil;
  FPointList.Free;
  FPlayerList.Free;
  inherited Destroy;
end;

function TESCardTable.PlayedCardsCount: Integer;
begin
  Result := Length(FPlayedCards);
end;

function TESCardTable.GetPlayedCards(Index: Integer): Integer;
begin
  Result := -1;
  if (Index >= 0) and (Index < Length(FPlayedCards)) then
    Result := FPlayedCards[Index];
end;

procedure TESCardTable.Notification(AComponent: TComponent;
  Operation: TOperation);
var
  I : Integer;
begin
  if csDesigning in ComponentState then
  if Operation = opRemove then
    if AComponent = FCardDeck then
      FCardDeck := nil
    else
    if AComponent = FSprite then
      FSprite := nil
    else
    for I := 0 to FPlayerList.Count - 1 do
      if FPlayerList[I].CardGroup = AComponent then
         FPlayerList[I].CardGroup := nil;
end;

procedure TESCardTable.PrepareDeck;
var
  I, J, A, T, R : Integer;
begin
  Lock;
  try
    Randomize;
    ResetKnowns;
    FTrickNo := 1;
    FLastTaker := nil;
    FPartyRefCount := Self.FDeckCount;
    if FDeckCount <> Length(FDeck) then
      SetLength(FDeck, FDeckCount);
    A := FDeckCount - 1;
    for I := 0 to A do
      if I + 2 <= 53 then
        FDeck[I] := I + 2
      else
        FDeck[I] := I - 50;

    { Shuffle the deck }
    for I := 0 to FShuffleCount - 1 do
      for J := 0 to A do
      begin
        R := Random(A+1);
        T := FDeck[R];
        FDeck[R] := FDeck[J];
        FDeck[J] := T;
      end;

    FLastTrick := False;

    FSuitBroken := False;

    { The topmost card of the deck }
    FDeckTopCard := 0;

    { Assign the bottom and top card of the deck }
    if FCardDeck <> nil then
    begin
      FCardDeck.DeckEmpty := False;
      FCardDeck.CardLast.ID := FDeck[Length(FDeck) -1];
      if FCardDeck.ShowLastCard then
        AddKnownID(FCardDeck.CardLast.ID);
      FCardDeck.CardFirst.ID := FDeck[0];
    end;
    if Assigned(FAfterPrepareDeck) then
      FAfterPrepareDeck(Self);
  finally
    Unlock;
  end;
end;

procedure TESCardTable.SetCardBack(const Value: TESBackType);
var
  I : Integer;
begin
  if Value <> FCardBack then
  begin
    FCardBack := Value;
    if FSprite <> nil then
    begin
      if FSprite.Busy then
        FSprite.AfterMove := BackChange
      else
        BackChange(Self);
    end;

    { FIND DECKS DAILOG AND CHANGE ALSO }
    for I := 0 to TForm(Owner).ComponentCount - 1 do
      if TForm(Owner).Components[I] is TESDecksDialog then
      begin
        if (TForm(Owner).Components[I] as TESDecksDialog).CardBack <> Value then
          (TForm(Owner).Components[I] as TESDecksDialog).CardBack :=  Value; 
        Break;
      end;
  end;
end;

procedure TESCardTable.SetNextCardPos(const Value: Integer);
begin
  if (Value >= 0) and (Value < 4) then
    FNextCardPos := Value;
end;

procedure TESCardTable.SetShowBack(const Value: Boolean);
begin
  FShowBack := Value;
  CardBottom.ShowBack := Value;
  CardLeft.ShowBack := Value;
  CardTop.ShowBack := Value;
  CardRight.ShowBack := Value;
end;

procedure TESCardTable.SetCardBottom(const Value: TESSingleCard);
begin
  FCardBottom.Assign(Value);
end;

procedure TESCardTable.SetCardLeft(const Value: TESSingleCard);
begin
  FCardLeft.Assign(Value);
end;

procedure TESCardTable.SetCardRight(const Value: TESSingleCard);
begin
  FCardRight.Assign(Value);
end;

procedure TESCardTable.SetCardTop(const Value: TESSingleCard);
begin
  FCardTop.Assign(Value);
end;

function TESCardTable.DrawCardFromDeck: integer;
begin
  Lock;
  try
  Result := -1;
  if (FDeckTopCard >= 0) and (FDeckTopCard < Length(FDeck)) then
  begin
    Result :=  FDeck[FDeckTopCard];
    if FCardDeck <> nil then
    begin
      FCardDeck.CardFirst.ID := FDeck[FDeckTopCard];
      case FCardDeck.DeckType of
        dcSingle :
          case FDeckTopCard of
            12 : FCardDeck.DecreaseDeck;
            25 : FCardDeck.DecreaseDeck;
            38 : FCardDeck.DecreaseDeck;
            51 : FCardDeck.DecreaseDeck;
          end;
        dcDouble :
          case FDeckTopCard of
             8 : FCardDeck.DecreaseDeck;
            16 : FCardDeck.DecreaseDeck;
            24 : FCardDeck.DecreaseDeck;
            32 : FCardDeck.DecreaseDeck;
            40 : FCardDeck.DecreaseDeck;
            48 : FCardDeck.DecreaseDeck;
            56 : FCardDeck.DecreaseDeck;
            64 : FCardDeck.DecreaseDeck;
            72 : FCardDeck.DecreaseDeck;
            80 : FCardDeck.DecreaseDeck;
            88 : FCardDeck.DecreaseDeck;
            96 : FCardDeck.DecreaseDeck;
           105 : FCardDeck.DecreaseDeck;
          end;
      end;
    end;
    Inc(FDeckTopCard);
    if FDeckTopCard >= Length(FDeck) then
    begin
      FLastTrick := True;
      FDeckTopCard := -1;
    end;
  end;
  finally
    Unlock;
  end;
end;

procedure TESCardTable.SetDeckType(const Value: TESDeckType);
begin
  FDeckType := Value;
  case Value of
    dcSingle : FDeckCount := 52;
    dcDouble : FDeckCount := 106;
  end;
  if FCardDeck <> nil then
    FCardDeck.DeckType := Value;
end;

procedure TESCardTable.Loaded;
begin
  inherited;
  if AutoEmpty then
    if not (csDesigning in ComponentState) then
    begin
      Empty := True;
      Clear;
      FNextCardPos := 0;
    end;
end;

function TESCardTable.GetCards(Index: Integer): TESSingleCard;
begin
  Result := nil;
  case Index of
    0 : Result := CardBottom;
    1 : Result := CardLeft;
    2 : Result := CardTop;
    3 : Result := CardRight;
  end;
end;

function TESCardTable.GetKnownCards(Index: Integer): Integer;
begin
  Result := -1;
  if (Index >= 2) and (Index <= 55) then
    Result :=  FKnownCards[Index];
end;

function TESCardTable.GetKnownValues(Index: Integer): Integer;
begin
  Result := -1;
  if (Index >= 2) and (Index <= 16) then
    Result :=  FKnownValues[Index];
end;

function TESCardTable.GetKnownSuites(Index: Integer): Integer;
begin
  Result := -1;
  if (Index >= 1) and (Index <= 5) then
    Result :=  FKnownSuites[Index];
end;

procedure TESCardTable.Deal(PlayerCards: TESCardGroup);
var
  I, A : Integer;
  X, Y, DX, DY, J : Integer;
begin
  Lock;
  try
    if FCardDeck <> nil then
    begin
      X := (FCardDeck.Left + FCardDeck.Width) - 70;
      Y := (FCardDeck.Top + FCardDeck.Height) - 95;
    end
    else
    begin
      X := Self.Left + Self.Width div 2 - 35;
      Y := Self.Top + Self.Height div 2 - 48;
    end;

    J := PlayerCards.CardsCount - 1;
    for I := 0 to J do
    begin
      if not PlayerCards[I].Reserved then
      begin
        A := DrawCardFromDeck;
        if A < 0 then
          Exit;
        PlayerCards[I].ID := A;
        DX := PlayerCards.Left + PlayerCards[I].FArea.Left;
        DY := PlayerCards.Top + PlayerCards[I].FArea.Top;
        if (FCardDeck <> nil) and FDealAnimation then
        begin
          if Sprite <> nil then
            if PlayerCards[I].ShowBack then
              Sprite.Move(X, Y, DX, DY, FCardLeft.FBackBitmap)
            else
              Sprite.Move(X, Y, DX, DY, ESImageList[A]);
        end
        else
          if (Sprite <> nil) and FDealAnimation then
            if PlayerCards[I].ShowBack then
              Sprite.Move(X, Y, DX, DY, FCardLeft.FBackBitmap)
            else
              Sprite.Move(X, Y, DX, DY, ESImageList[A]);
        if PlayerCards[I].Empty then
          PlayerCards[I].Empty := False;
      end;
    end;
  finally
    Unlock;
  end;
end;

procedure TESCardTable.DealToTable;
var
  I, J : Integer;
  A : Integer;
  X, Y, DX, DY : Integer;
  AShowBack : Boolean;
  TC : Integer;
begin
  Lock;
  try
    TC := FNextCardPos;
    DX := 0; DY := 0;
    if FCardDeck <> nil then
    begin
      X := (FCardDeck.Left + FCardDeck.Width) - 70;
      Y := (FCardDeck.Top + FCardDeck.Height) - 95;
    end
    else
    begin
      X := 0;
      Y := 0;
    end;


    J :=  FTableCloseCards + FTableOpenCards;
    for I := 1 to J do
    begin
      A := DrawCardFromDeck;
      if A < 0 then
        Exit;
      AShowBack :=  not (I > FTableCloseCards);
      TC := FNextCardPos;
      case FNextCardPos of
        0 : begin DX := 24; DY := 60; end;
        1 : begin DX :=  0; DY := 25; end;
        2 : begin DX := 35; DY := 0;  end;
        3 : begin DX := 60; DY := 35; end;
      end;
      DX := Left + DX;
      DY := Top + DY;
      if (FCardDeck <> nil) and FDealAnimation then
      begin
        if Sprite <> nil then
          if AShowBack then
            Sprite.Move(X, Y, DX, DY, FCardDeck.CardFirst.FBackBitmap)
          else
            Sprite.Move(X, Y, DX, DY, ESImageList[A]);
      end;
      AddCardID(A, AShowBack);
    end;
    if Assigned(FAfterDealToTable) then
      FAfterDealToTable(Self, PlayedCardsCount, TC, Cards[TC]);
  finally
    Unlock;
  end;
end;

procedure TESCardTable.SetTableOpenCards(const Value: Integer);
begin
  FTableOpenCards := Value;
end;

procedure TESCardTable.SetTableCloseCards(const Value: Integer);
begin
  FTableCloseCards := Value;
end;

procedure TESCardTable.SetShuffleCount(const Value: Integer);
begin
  if Value >= 0 then
    FShuffleCount := Value;
end;

procedure TESCardTable.SendTableTo(PlayerCards: TESCardGroup);
var
  I, Z, DX, DY, X, Y : Integer;
begin
  Lock;
  try
    FLastTaker := PlayerCards;
    if FDelay > 0 then
      Wait(FDelay);
    DX := 0;
    DY := 0;

    if PlayerCards <> nil then
    case PlayerCards.CascadeSide of
      csRight :
      if Top < PlayerCards.Top then { PLAYER CARDS ARE AT THE BOTTOM OF THE DECK }
      begin
        DX := PlayerCards.Left + (PlayerCards.Width div 2 - 35);
        DY := PlayerCards.Top + PlayerCards.Height;
      end
      else
      begin
        DX := PlayerCards.Left + (PlayerCards.Width div 2 - 35);
        DY := PlayerCards.Top - 96;
      end;
      csDown :
      if Left < PlayerCards.Left then { PLAYER CARDS ARE AT THE RIGHT OF THE DECK }
      begin
        DX := PlayerCards.Left + PlayerCards.Width;
        DY := PlayerCards.Top + (PlayerCards.Height div 2 - 48);
      end
      else
      begin
        DX := PlayerCards.Left - 71;
        DY := PlayerCards.Top + (PlayerCards.Height div 2 - 48);
      end;
    end;

    Z := FNextCardPos;
    for I := 0 to 3 {M} do
    begin
      if FAutoPosDirection = tdClockWise then
      begin
        Dec(Z);
        if Z < 0 then
          Z := 3;
      end
      else
      begin
        Inc(Z);
        if Z > 3 then
          Z := 0;
      end;

      if not Cards[Z].Empty then
      begin
        Cards[Z].Empty := True;
        Redraw;
        if (FSprite <> nil) and (PlayerCards <> nil) then
        begin
          X := Cards[Z].FArea.Left + Self.Left;
          Y := Cards[Z].FArea.Top + Self.Top;
          if Cards[Z].ShowBack then
            Sprite.Move(X, Y, DX, DY, Cards[Z].FBackBitmap)
          else
            Sprite.Move(X, Y, DX, DY, Cards[Z].FFaceBitmap);
        end;
      end;
    end;

    if PlayerCards <> nil then
      PlayerCards.AddToTakenCards(FPlayedCards);

    Clear;
    FSuit := stJoker;

    if FPartyRefCount <=0 then
    begin
      if FRandomDeck then
        ChangeDeckRandom;
      if Assigned(FAfterPartyFinish) then
        FAfterPartyFinish(Self);
    end;

    if PlayerCards <> nil then
    if FTakerPlay then
    begin
      for I := 0 to FPlayerList.Count - 1 do
        if FPlayerList[I].CardGroup <> nil then
        if FPlayerList[I].CardGroup = PlayerCards then
        begin
          FPlayerNoToPlay := I;
          Break;
        end;
      PlayerCards.PlayCard;
    end;
  finally
    UnLock;
  end;
end;

procedure TESCardTable.SetRandomCards(const Value: Boolean);
var
  I : Integer;
begin
  FRandomCards := Value;
  if Value and ((csDesigning in ComponentState) or (not FAutoEmpty)) then
  begin
    Randomize;
    for I := 0 to 3 do
      Cards[I].ID := Random(52) + 2;
  end
  else
  if csDesigning in ComponentState then
    for I := 0 to 3 do
      Cards[I].ID := 14;
end;

procedure TESCardTable.SetDelay(const Value: Integer);
begin
  if Value >=0 then
    FDelay := Value;
end;

function TESCardTable.BiggestCardOwner: TESCardGroup;
var
  I : Integer;
  V : Integer;
  A : Integer;
  P1, P2, Y : Integer;
  F : Boolean;
begin
  Lock;
  try
  F := False;
  P1 := -1;
  P2 := -1;
  V := 0;
  Y := 0;
  for I := 0 to 3 do
    if Cards[I].CardOwner <> nil then
    begin
      A := Cards[I].Value;
      if (not Cards[I].Empty) and (Cards[I].CardOwner is TESCardGroup) then
      begin
        if (Cards[I].Suit = FSuit) and (A > V) then
        begin
          V := A;
          P1 := I;
        end
        else
        if  (Cards[I].Suit <> FSuit) and (Cards[I].Suit = FStrongSuit) and (A > Y) then
        begin
          F := True;
          Y := A;
          P2 := I;
        end
      end;
    end;
    if F then
      Result := TESCardGroup(Cards[P2].Cardowner)
    else
      Result := TESCardGroup(Cards[P1].Cardowner);
  finally
    Unlock;
  end;
end;

function TESCardTable.SmallestCardOwner: TESCardGroup;
var
  I : Integer;
  V : Integer;
  A : Integer;
  P1, P2, Y : Integer;
  F : Boolean;
begin
  Lock;
  try
  F := False;
  P1 := -1;
  P2 := -1;
  V := 100;
  Y := 100;
  for I := 0 to 3 do
    if Cards[I].CardOwner <> nil then
    begin
      A := Cards[I].Value;
      if (not Cards[I].Empty) and (Cards[I].CardOwner is TESCardGroup) then
      begin
        if (Cards[I].Suit = FSuit) and (A < V) then
        begin
          V := A;
          P1 := I;
        end
        else
        if  (Cards[I].Suit <> FSuit) and (Cards[I].Suit = FStrongSuit) and (A < Y) then
        begin
          F := True;
          Y := A;
          P2 := I;
        end
      end;
    end;
    if F then
      Result := TESCardGroup(Cards[P2].Cardowner)
    else
      Result := TESCardGroup(Cards[P1].Cardowner);
  finally
    Unlock;
  end;
end;

procedure TESCardTable.SetCardsPerTrick(const Value: Integer);
begin
  if Value >= 1 then
    FCardsPerTrick := Value;
end;

procedure TESCardTable.Deal(ChangeDealer : Boolean = False);
var
  I, J : Integer;
begin
  Lock;
  try
    for I := 0 to FPlayerList.Count - 1 do
      if FPlayerList[I].CardGroup <> nil then
      if FPlayerList[I].CardGroup.FDealer then
      begin
        FPlayerNoToPlay := GetNextPlayerPos(I);
        if ChangeDealer then
        begin
          FPlayerList[I].CardGroup.FDealer := False;
          FPlayerList[FPlayerNoToPlay].CardGroup.FDealer := True;
          FPlayerNoToPlay := GetNextPlayerPos(FPlayerNoToPlay);
        end;
        Break;
      end;

    FTrickRefCount := 0;

    I := 0;
    J := FPlayerNoToPlay;
    repeat
      if FPlayerList[J].CardGroup <> nil then
        Deal(FPlayerList[J].CardGroup);
      J := GetNextPlayerPos(J);
      Inc(I);
    until I = GetPlayerCount;

    if Assigned(FAfterDealingFinish) then
      FAfterDealingFinish(Self);

    if FPlayerList.Count > 0 then
    if FPlayerList[FPlayerNoToPlay].CardGroup <> nil then
      FPlayerList[FPlayerNoToPlay].CardGroup.PlayCard;
  finally
    Unlock;
  end;
end;

function TESCardTable.GetDeckCards(Index: Integer): Integer;
begin
  if (Index >=0) and (Index < Length(FDeck)) then
    Result := FDeck[Index]
  else
    Result := -1;
end;

procedure TESCardTable.SetDeckCards(Index: Integer; const Value: Integer);
begin
  if (Value >=1) and (Value <=54) then
    FDeck[Index] := Value;
end;

function TESCardTable.GetCardPoint(CardID: Integer): Integer;
var
  I : Integer;
begin
  Lock;
  try
  Result := 0;
  for I := 0 to FPointList.Count - 1 do
    if FPointList[I].CardID = CardID then
    begin
      Result := FPointList[I].Points;
      Break;
    end;
  finally
    Unlock;
  end;
end;


function TESCardTable.GetNextPlayerPos(PlayerPos: Integer): Integer;
begin
  Inc(PlayerPos);
  if PlayerPos = GetPlayerCount then
    PlayerPos := 0;
  Result := PlayerPos;
end;

function TESCardTable.GetPlayerCount: Integer;
begin
  Result := FPlayerList.Count;
end;

function TESCardTable.GetPrevPlayerPos(PlayerPos: Integer): Integer;
begin
  Dec(PlayerPos);
  if PlayerPos < 0 then
    PlayerPos := GetPlayerCount - 1;
  Result := PlayerPos;
end;

procedure TESCardTable.BackChange(Sender: TObject);
var
  I : Integer;
begin
  if FSprite <> nil then
    FSprite.AfterMove := nil;
  CardBottom.CardBack := FCardBack;
  CardLeft.CardBack := FCardBack;
  CardTop.CardBack := FCardBack;
  CardRight.CardBack := FCardBack;
  for I := 0 to FPlayerList.Count - 1 do
    if FPlayerList[I].CardGroup <> nil then
      FPlayerList[I].CardGroup.CardBack := FCardBack;
  if FCardDeck <> nil then
    FCardDeck.CardBack := FCardBack;
end;

procedure TESCardTable.ShowTakenCards;
var
  I : Integer;
begin
  for I := 0 to FPlayerList.Count - 1 do
    if FPlayerList[I].CardGroup <> nil then
      FPlayerList[I].CardGroup.ShowTakenCards;
end;

procedure TESCardTable.HideTakenCards;
var
  I : Integer;
begin
  for I := 0 to FPlayerList.Count - 1 do
    if FPlayerList[I].CardGroup <> nil then
      FPlayerList[I].CardGroup.HideTakenCards;
end;

procedure TESCardTable.ClearTakenCards;
var
  I : Integer;
begin
  for I := 0 to FPlayerList.Count - 1 do
    if FPlayerList[I].CardGroup <> nil then
      FPlayerList[I].CardGroup.ClearTakenCards;
end;

procedure TESCardTable.ChangeDeckNext;
var
  A : Integer;
begin
  A := GetCardBackID(FCardBack);
  Inc(A);
  if A > 67 then
    A := 56;
  CardBack := GetCardBackType(A);
end;

procedure TESCardTable.ChangeDeckPrev;
var
  A : Integer;
begin
  A := GetCardBackID(FCardBack);
  Dec(A);
  if A < 56 then
    A := 67;
  CardBack := GetCardBackType(A);
end;

procedure TESCardTable.ChangeDeckRandom;
begin
  CardBack := GetCardBackType(Random(12) + 56);
end;

procedure TESCardTable.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  TakeIt : Boolean;
begin
  inherited;
  if (not FBusy) then
  begin
    Lock;
    try
      TakeIt := False;
      if (Assigned(FOnCardClick)) and (FTopCardPos >=0) and (not Cards[FTopCardPos].Empty) then
        FOnCardClick(Self, Cards[FTopCardPos], TakeIt);
      if TakeIt then
        SendTopCardTo(FindHumanPlayer);
    finally
      UnLock;
    end;
  end;
end;

procedure TESCardTable.SendCardFromDeckTo(PlayerCards: TESCardGroup);
var
  Pos, ID : Integer;
begin
  if PlayerCards <> nil then
  begin
  if (FDeckTakeDelay > 0) and (PlayerCards.Controller = ctComputer) then
    Wait(FDeckTakeDelay);
  ID := DrawCardFromDeck;
  if (FCardDeck <> nil) and (ID > 0) then
  begin
  Pos := PlayerCards.FindReservedPos;

  if Sprite <> nil then
    if PlayerCards[Pos].ShowBack then
      Sprite.Move(FCardDeck.FCardFirst.FArea.Left + FCardDeck.Left, FCardDeck.FCardFirst.FArea.Top + FCardDeck.Top,
       PlayerCards[Pos].FArea.Left + PlayerCards.Left, PlayerCards[Pos].FArea.Top + PlayerCards.Top,
       FCardDeck.FCardFirst.BackBitmap)
    else
      Sprite.Move(FCardDeck.FCardFirst.FArea.Left + FCardDeck.Left, FCardDeck.FCardFirst.FArea.Top + FCardDeck.Top,
       PlayerCards[Pos].FArea.Left + PlayerCards.Left, PlayerCards[Pos].FArea.Top + PlayerCards.Top,
       ESImageList[ID]);

  PlayerCards[Pos].ID := ID;
  if PlayerCards[Pos].Empty then
    PlayerCards[Pos].Empty := False;

  end;
  end;
end;

procedure TESCardTable.SendTopCardTo(PlayerCards: TESCardGroup);
var
  Pos : Integer;
begin
  if PlayerCards <> nil then
  begin
  if (FDelay > 0) and (PlayerCards.Controller = ctComputer) then
    Wait(FDelay);
  Pos := PlayerCards.FindReservedPos;
  Cards[FTopCardPos].Empty := True;

  { REDRAW THE REMAINING CARDS }

  ReDraw;

  if Sprite <> nil then
    Sprite.Move(Cards[FTopCardPos].FArea.Left + Left, Cards[FTopCardPos].FArea.Top + Top,
       PlayerCards[Pos].FArea.Left + PlayerCards.Left, PlayerCards[Pos].FArea.Top + PlayerCards.Top,
       Cards[FTopCardPos].FaceBitmap);

  PlayerCards[Pos].ID := Cards[FTopCardPos].ID;
  if PlayerCards[Pos].Empty then
    PlayerCards[Pos].Empty := False;


  if Length(FPlayedCards) > 0 then
    SetLength(FPlayedCards, Length(FPlayedCards) - 1);

  FNextCardPos := FTopCardPos;
  Inc(FTopCardPos);
  if FTopCardPos > 3 then
    FTopCardPos := 0;
  end;
end;

function TESCardTable.FindHumanPlayer: TESCardGroup;
var
  I : Integer;
begin
  Result := nil;
  for  I := 0 to FPlayerList.Count - 1 do
    if FPlayerList[I].CardGroup <> nil then
      if FPlayerList[I].CardGroup.Controller = ctHuman then
      begin
        Result := FPlayerList[I].CardGroup;
        Break;
      end;
end;

procedure TESCardTable.SetDeckTakeDelay(const Value: Integer);
begin
  if Value >=0 then
    FDeckTakeDelay := Value;
end;

procedure TESCardTable.ReDraw;
var
  M, K : Integer;
begin
  if FAutoPosDirection = tdClockWise then
  begin
    M := FTopCardPos;
    for K := 0 to 3 do
    begin
      Inc(M);
      if M > 3 then
        M := 0;
      if not Cards[M].Empty then
        Cards[M].Draw(False);
    end;
  end
  else
  begin
    M := FTopCardPos;
    for K := 0 to 3 do
    begin
      Dec(M);
      if M < 0 then
        M := 3;
      if not Cards[M].Empty then
        Cards[M].Draw(False);
    end;
  end;
end;

procedure TESCardTable.StartPlay;
begin
  if not Busy then
    FPlayerList[FPlayerNoToPlay].CardGroup.PlayCard;
end;

procedure TESCardTable.SetCardDeck(const Value: TESCardDeck);
begin
  FCardDeck := Value;
  if csDesigning in ComponentState then
  if Value <> nil then
    Value.Table := Self;
end;

procedure TESCardTable.SetSprite(const Value: TESCustomSprite);
var
  I : Integer;
begin
  inherited;
  if csDesigning in ComponentState then
  if Value <> nil then
    for I := 0 to FPlayerList.Count - 1 do
      if FPlayerList[I].CardGroup <> nil then
        FPlayerList[I].CardGroup.Sprite := FSprite;

end;

procedure TESCardTable.TimerUp(Sender: TObject);
begin
  FWaiting := False;
end;

procedure TESCardTable.Wait(Miliseconds: Integer);
begin
  if not FTimer.Enabled then
  begin
    FWaiting := True;
    FTimer.Interval := Miliseconds;
    FTimer.Enabled := True;
    repeat
      Application.ProcessMessages;
    until not FWaiting;
    FTimer.Enabled := False;
  end;
end;

procedure TESCardTable.AddKnownID(ID: Integer);
var
  S : TESSuitType;
  C : Integer;
begin
  if FDeckType = dcSingle then
    C := 1
  else
  if ID <= 53 then
    C := 2
  else
    C := 1;
  if FKnownCards[ID] = C then
    Exit;
  Inc(FKnownCards[ID]);
  Inc(FKnownValues[GetCardValue(ID)]);
  S := GetCardSuit(ID);
  case S of
    stClub    : Inc(FKnownSuites[1]);
    stDiamond : Inc(FKnownSuites[2]);
    stSpade   : Inc(FKnownSuites[3]);
    stHeart   : Inc(FKnownSuites[4]);
    stJoker   : Inc(FKnownSuites[5]);
  end;
end;

procedure TESCardTable.ResetKnowns;
var
  I : Integer;
begin
  for I := 2 to 55 do
    FKnownCards[I] := 0;
  for I := 2 to 16 do
    FKnownValues[I] := 0;
  for I := 1 to 5 do
    FKnownSuites[I] := 0;
end;

{$IFDEF NETENABLE}
procedure TESCardTable.SetNetManager(const Value: TESNetManager);
begin
  FNetManager := Value;
end;
{$ENDIF}

{ TESCardDeck }

constructor TESCardDeck.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FDealAnimation := True;
  SetLength(FDeck, 0);
  FDeckCardCount := 52;
  FShuffleCount := 500;
  FDeckCount := 3;
  FShowLastCard := True;
  FCardLast := TESSingleCard.Create(Self, PaintBitmap);
  FCardLast.ShowBack := False;
  FCardLast.Position := 0;
  FCardFirst := TESSingleCard.Create(Self, PaintBitmap);
  FCardFirst.Position := 1;
  Width := PaintBitmap.Width;
  Height := PaintBitmap.Height;
  Empty := False;
end;

procedure TESCardDeck.Deal(PlayerCards : TESCardGroup; CreateCards : Boolean = False; Count : Integer = 1);
var
  I, A : Integer;
  X, Y, DX, DY, J : Integer;
begin
  if FBusy then
    Exit;
  Lock;
  try
    X := (Left + Width) - 70;
    Y := (Top + Height) - 95;
    if CreateCards then
    begin
      for I := 0 to Count - 1 do
      begin
        A := DrawCardFromDeck;
        if A >= 2 then
        begin
          if PlayerCards.CardsCount > 0 then
          begin
            DX := PlayerCards.LastCard.Left;
            DY := PlayerCards.LastCard.Top;
          end
          else
          begin
            DX := PlayerCards.Left;
            DY := PlayerCards.Top;
          end;
          if (Sprite <> nil) and FDealAnimation then
            Sprite.Move(X, Y, DX, DY, ESImageList[A]);
          with PlayerCards.CardList.Add do
            Card.ID := A;
        end;
      end;
   end
   else
    begin
    J := PlayerCards.CardsCount - 1;
    for I := 0 to J do
    begin
      if not PlayerCards[I].Reserved then
      begin
        A := DrawCardFromDeck;
        if A < 0 then
          PlayerCards[I].Empty := True
        else
        begin
          PlayerCards[I].ID := A;
          DX := PlayerCards.Left + PlayerCards[I].FArea.Left;
          DY := PlayerCards.Top + PlayerCards[I].FArea.Top;
          if FDealAnimation then
          if Sprite <> nil then
            if PlayerCards[I].ShowBack then
              Sprite.Move(X, Y, DX, DY, FCardFirst.FBackBitmap)
            else
              Sprite.Move(X, Y, DX, DY, ESImageList[A]);
          if PlayerCards[I].Empty then
            PlayerCards[I].Empty := False;
          end;
        end;
    end;
    end;
  finally
    Unlock;
  end;
end;

procedure TESCardDeck.DecreaseDeck;
begin
  DeckCount := DeckCount - 1;
end;

destructor TESCardDeck.Destroy;
begin
  FDeck := nil;
  FCardFirst.Free;
  FCardLast.Free;
  inherited Destroy;
end;

function TESCardDeck.DrawCardFromDeck : Integer;
begin
  Lock;
  try
  Result := -1;
  if (FDeckTopCard >= 0) and (FDeckTopCard < Length(FDeck)) then
  begin
    Result :=  FDeck[FDeckTopCard];
    CardFirst.ID := FDeck[FDeckTopCard];
    case DeckType of
      dcSingle :
        case FDeckTopCard of
          38 : DecreaseDeck;
          25 : DecreaseDeck;
          12 : DecreaseDeck;
          0  : DecreaseDeck;
        end;
      dcDouble :
        case FDeckTopCard of
          96: DecreaseDeck;
          88: DecreaseDeck;
          80: DecreaseDeck;
          72: DecreaseDeck;
          64: DecreaseDeck;
          56: DecreaseDeck;
          48: DecreaseDeck;
          40: DecreaseDeck;
          32: DecreaseDeck;
          24: DecreaseDeck;
          16: DecreaseDeck;
          8 : DecreaseDeck;
          0 : DecreaseDeck;
        end;
    end;
  end;
  Dec(FDeckTopCard);
  if FDeckTopCard < 0 then
    FDeckTopCard := -1;
  finally
    Unlock;
  end;
end;


procedure TESCardDeck.IncreaseDeck;
begin
  DeckCount := DeckCount + 1;
end;

procedure TESCardDeck.Loaded;
begin
  inherited;
  if AutoEmpty then
    if not (csDesigning in ComponentState) then
      DeckEmpty := True;
end;


procedure TESCardDeck.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  TakeIt : Boolean;
begin
  inherited;
  if FTable <> nil then
  if (not FTable.Busy) and (not FBusy) then
  begin
    Lock;
    try
      TakeIt := False;
      if (Assigned(FOnCardClick)) then
        FOnCardClick(Self, TakeIt);
      if TakeIt then
        FTable.SendCardFromDeckTo(FTable.FindHumanPlayer);
      finally
        Unlock;
    end;
  end;
end;

procedure TESCardDeck.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if csDesigning in ComponentState then
  if Operation = opRemove then
    if AComponent = FTable then
      FTable := nil
end;

procedure TESCardDeck.PrepareDeck;
var
  I, J, A, T, R : Integer;
begin
  if FBusy then
    Exit;
  Lock;
  try
    Randomize;
    if FDeckCardCount <> Length(FDeck) then
      SetLength(FDeck, FDeckCardCount);
    A := FDeckCardCount - 1;
    for I := 0 to A do
      if I + 2 <= 53 then
        FDeck[I] := I + 2
      else
        FDeck[I] := I - 50;

    { Shuffle the deck }
    for I := 0 to FShuffleCount - 1 do
      for J := 0 to A do
      begin
        R := Random(A+1);
        T := FDeck[R];
        FDeck[R] := FDeck[J];
        FDeck[J] := T;
      end;

    { The topmost card of the deck }
    FDeckTopCard := Length(FDeck) - 1;

    { Assign the bottom and top card of the deck }
    CardLast.ID := FDeck[Length(FDeck) -1];
    CardFirst.ID := FDeck[0];
    DeckEmpty := False;
  finally
    Unlock;
  end;
end;

procedure TESCardDeck.RepaintCanvas(PaintAll: Boolean);
begin
  CardLast.Draw(PaintAll);
  CardFirst.Draw(PaintAll);
end;


procedure TESCardDeck.SetCardBack(const Value: TESBackType);
begin
  FCardBack := Value;
  CardLast.CardBack := Value;
  CardFirst.CardBack := Value;
end;

procedure TESCardDeck.SetCardFirst(const Value: TESSingleCard);
begin
  FCardFirst.Assign(Value);
end;

procedure TESCardDeck.SetCardLast(const Value: TESSingleCard);
begin
  FCardLast.Assign(Value);
end;

procedure TESCardDeck.SetCards(Index: Integer; const Value: Integer);
begin
  if (Index >= 0) and (Index <= Length(FDeck)) then
    FDeck[Index] := Value;
end;

function TESCardDeck.GetCards(Index: Integer): Integer;
begin
  Result := -1;
  if (Index >= 0) and (Index <= Length(FDeck)) then
    Result := FDeck[Index];
end;

procedure TESCardDeck.SetDeckCount(const Value: Integer);
begin
  if (Value >= 0) then
  begin
    FDeckCount := Value;
    RepaintCanvas(False);
  end
  else
  begin
    DeckEmpty := True;
    SetDeckType(FDeckType);
  end;
end;

procedure TESCardDeck.SetDeckEmpty(const Value: Boolean);
begin
  FDeckEmpty := Value;
  if Value = False then
    case DeckType of
      dcSingle : FDeckCount := 3;
      dcDouble : FDeckCount := 12;
    end;
  RepaintCanvas(False);
end;

procedure TESCardDeck.SetDeckTo(Cards: TESCardGroup);
var
  I : Integer;
begin
  if Cards.CardsCount > 0 then
  begin
    Lock;
    try
    SetLength(FDeck, Cards.CardsCount);
    for I := 0 to Cards.CardsCount - 1 do
      FDeck[I] := Cards[Cards.CardsCount - 1 - I].ID;
    FDeckTopCard := Cards.CardsCount - 1;
    DeckEmpty := False;
    case DeckType of
      dcSingle :
        case FDeckTopCard of
          0..11 : DeckCount := 0;
         12..24 : DeckCount := 1;
         25..37 : DeckCount := 2;
         38..52 : DeckCount := 3;
        end;
      dcDouble :
        case FDeckTopCard of
         0..7   : DeckCount := 0;
         8..15 : DeckCount := 1;
         16..23 : DeckCount := 2;
         24..31 : DeckCount := 3;
         32..39 : DeckCount := 4;
         40..47 : DeckCount := 5;
         48..55 : DeckCount := 6;
         56..63 : DeckCount := 7;
         64..71 : DeckCount := 8;
         72..79 : DeckCount := 9;
         80..87 : DeckCount := 10;
         88..95 : DeckCount := 11;
         96..106: DeckCount := 12;
        end;
    end;
    finally
      UnLock;
    end;
  end;
end;

procedure TESCardDeck.SetDeckType(const Value: TESDeckType);
begin
  FDeckType := Value;
  if Value = dcSingle then
  begin
    PaintBitmap.Canvas.FillRect(Rect(16,0,PaintBitmap.Width, 20));
    DeckCount := 3;
    FDeckCardCount := 52;
  end
  else
  begin
    DeckCount := 12;
    FDeckCardCount := 106;
  end;
end;

procedure TESCardDeck.SetShowBack(const Value: Boolean);
begin
  FShowBack := Value;
  CardLast.ShowBack := False;
  CardFirst.ShowBack := Value;
end;

procedure TESCardDeck.SetShowLastCard(const Value: Boolean);
begin
  FShowLastCard := Value;
  RepaintCanvas(False);
end;

{ MISC ROUTINES }

procedure DestroyImageList;
var
  I : Integer;
begin
  Dec(ESRefCount);
  if ESRefCount = 0 then
    for I := 2 to 70 do
      ESImageList[I].Free;
end;

procedure InitializeImageList;
var
  I : Integer;
  A : Integer;
begin
  if ESRefCount = 0 then
    for I := 2 to 70 do
    begin
      A := I;
      ESImageList[I] := TBitmap.Create;

      { AS' LARI AYARLA }

      case A of
        14, 27, 40, 53 : A := I - 13;
      end;

      { KUPA, MACA YER DEGISTIR }

      if (A>=27) and (A<=39) then
        A := A + 13
      else
      if (A>=40) and (A<=52) then
        A := A - 13;

      { RESIMLERI AYARLA }

      if A >= 54 then
        Dec(A);

      ESImageList[I].LoadFromResourceID(HInstance, A);
      ESImageList[I].Dormant;
      ESImageList[I].ReleasePalette;
      if ESImageList[I].Monochrome then
        ESImageList[I].Monochrome := False;
      if I = 70 then
        ESImageList[I].TransparentColor := clWhite
      else
        ESImageList[I].TransparentColor := $00FF00FF;
      ESImageList[I].Transparent := True;
      DrawCardFrame(ESImageList[I], ESImageList[I].TransparentColor);
    end;
  Inc(ESRefCount);
end;

function GetCardValue(CardID : Integer) : Integer;
begin
  Result := 0;
  if (CardID >= 2) and (CardID < 56) then
  begin
    case CardID of
      2..14  : Result := CardID;
      15..27 : Result := CardID - 13;
      28..40 : Result := CardID - 26;
      41..53 : Result := CardID - 39;
      54..55 : Result := CardID - 39;
    end;
  end;
end;

function GetCardSuit(CardID : Integer) : TESSuitType;
begin
  Result := stJoker;
  if (CardID >= 2) and (CardID < 56) then
  begin
    case CardID of
      2..14  : Result := stClub;
      15..27 : Result := stDiamond;
      28..40 : Result := stSpade;
      41..53 : Result := stHeart;
      54..55 : Result := stJoker;
    end;
  end;
end;

function GetCardBackType(ID : Integer) : TESBackType;
begin
  Result := cbDefault;
  case ID of
    56 : Result := cbDefault;
    57 : Result := cbLabyrinth;
    58 : Result := cbIvyBlack;
    59 : Result := cbIvyBlue;
    60 : Result := cbFishCyan;
    61 : Result := cbFishBlue;
    62 : Result := cbHawai;
    63 : Result := cbIceCream;
    64 : Result := cbRobot;
    65 : Result := cbTricky;
    66 : Result := cbFlower;
    67 : Result := cbCastle;
    68 : Result := cbX;
    69 : Result := cbO;
    70 : Result := cbDots;
  end;
end;

function GetCardBackID(ACardBackType : TESBackType) : Integer;
var
  X : Integer;
begin
  X := -1;
  case ACardBackType of
    cbDefault   : X := 56;
    cbLabyrinth : X := 57;
    cbIvyBlack  : X := 58;
    cbIvyBlue   : X := 59;
    cbFishCyan  : X := 60;
    cbFishBlue  : X := 61;
    cbHawai     : X := 62;
    cbIceCream  : X := 63;
    cbRobot     : X := 64;
    cbTricky    : X := 65;
    cbFlower    : X := 66;
    cbCastle    : X := 67;
    cbX         : X := 68;
    cbO         : X := 69;
    cbDots      : X := 70;
  end;
  Result := X;
end;

procedure QuickSort(var SortArray : TESSortArray);

  procedure PartialSort(Left, Right : Integer; var A : TESSortArray);
  var
    I, J, K : Integer;

    procedure Switch(var A, B : Integer);
    var
      C : Integer;
    begin
      if A <> B then
      begin
        C := A;
        A := B;
        B := C;
      end;
    end;

  begin
    K := (A[Left].Key + A[Right].Key) div 2;
    I := Left;
    J := Right;
    repeat
      while A[I].Key < K do
        Inc(I);
      while K < A[J].Key do
        Dec(J);
      if I <= J then
      begin
        Switch(A[I].Key, A[J].Key);
        Switch(A[I].Data, A[J].Data);
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if Left < J then
      PartialSort(Left, J, A);
    if I < Right then
      PartialSort(I, Right, A);
  end;

begin
  PartialSort(0, Length(SortArray)-1, SortArray);
end;

procedure TESCardDeck.SetCardsCount(const Value: Integer);
begin
  if Value >= 0 then
    SetLength(FDeck, Value);
end;

function TESCardDeck.GetCardsCount: Integer;
begin
  Result := Length(FDeck);
end;

{ TESPlayerItem }

procedure TESPlayerItem.SetCardGroup(const Value: TESCardGroup);
begin
  FCardGroup := Value;
  if csDesigning in TESCardTable(TESPlayerList(Collection).Owner).ComponentState then
  if Value <> nil then
  begin
    Value.Table := TESCardTable(TESPlayerList(Collection).Owner);
    if TESCardTable(TESPlayerList(Collection).Owner).Sprite <> nil then
      Value.Sprite := TESCardTable(TESPlayerList(Collection).Owner).Sprite;
  end;
end;

end.

